#!/opt/hsdi/qddb/bin/qwish
lappend auto_path $qddb_library/fx
# $RCSfile: xqbib.tcl,v $ $Revision: 1.3 $ $Date: 2001/03/11 12:11:16 $
#
# Copyright (C) 1995-2001 Herrin Software Development, Inc.
# All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

package require BWidget

proc Fx:Prologue {config {s ""} {bannergif ""} {bannerxbm ""} {bannertitle ""}} {
    global auto_path blt_library fx_config fx_config_dir fx_blt \
	    fx_monochrome argv qddbscript qddb_library argv argv0

    if {[info exists blt_library]} {
	lappend auto_path $blt_library
    }
    set fx_config_dir .${config}_config
    if {"$s" == ""} {
	if {[catch [list qddb_schema open "[lindex $argv 0]"] s] != 0} {
	    puts stderr "Cannot open Schema for relation: \"[lindex $argv 0]\"\n($s)\n"
	    puts stderr "Usage: $argv0 RelationName"
	    exit 1
	}
    }
    set qddbscript(schema) $s
    Fx:Init $s
    set scrwid [winfo screenwidth .]
    set scrht [winfo screenheight .]
    
    toplevel .banner -relief raised -bd 2
    wm overrideredirect .banner 1
    frame .banner.f -bg black
    pack .banner.f -expand on -fill both
    if {[winfo depth .] < 8} {
	if {[string length $bannerxbm] == 0} {
	    label .banner.f.l -bitmap @$qddb_library/fx/pixmaps/qddb.xbm
	} else {
	    label .banner.f.l -bitmap @$bannerxbm
	}
    } else {
	if {[string length $bannergif] == 0} {
	    image create photo qddb_color -file $qddb_library/fx/pixmaps/qddb_color.gif
	    label .banner.f.l -image qddb_color -justify c -bd 0
	} else {
	    image create photo qddb_color -file $bannergif
	    label .banner.f.l -image qddb_color -justify c -bd 0
	}
    }
    pack .banner.f.l -side top -expand on -fill x -padx 0m -pady 0m
    
    set msgcolor black
    if {!$fx_monochrome} {
	.banner.f.l configure -bg $msgcolor
	.banner.f configure -bg $msgcolor
    }
    set path [qddb_schema path $s]
    set tail [file tail $path]
    if {[string compare $tail ""] == 0} {
	set tail [file tail [file dirname $path]]
    }
    if {[string length $bannertitle] == 0} {
	wm title .banner "$config ($tail)"
    } else {
	wm title .banner $bannertitle
    }
    wm iconname . "$tail"
    wm withdraw .
    if {$fx_blt} {
	blt::busy hold .banner.f.l
    }
    wm withdraw .banner
    update idletasks
    update
    wm geometry .banner \
	    +[expr $scrwid/2 - [winfo reqwidth .banner]/2]+[expr $scrht/2 - [winfo reqheight .banner]/2]
    wm deiconify .banner
    update idletasks
    update
    wm title . "Qddb ($tail)"
    set qddbscript(trans_name) [split [qddb_schema path $s] /]
    set qddbscript(trans_name) [glob ~]/.${config}_restrict/[join $qddbscript(trans_name) .]
    return $s
}

proc Fx:Epilogue {} {
    menubar configure -instances [Fx_Entry::GetInstances] -frames [Fx_Frame::GetInstances]
    menubar SearchModeProc
    Fx:InitConfigure
    destroy .banner
}

proc Fx:InitConfigure {} {
    global fx_config fx_rootx fx_rooty

    Fx_Entry::BeforeReconfigure {wm withdraw .}
    Fx_Entry::AfterReconfigure {Fx:Reconfigure}
    Fx_Menubar::BeforeReconfigure {wm withdraw .}
    Fx_Menubar::AfterReconfigure {Fx:Reconfigure}
    Fx:Reconfigure
    bind . <Configure> {Fx:Configure}
}

proc Fx:Configure {} {
    global fx_config

    set geo [split [wm geometry .] +]
    set x [lindex $geo 1]
    set y [lindex $geo 2]
    set fx_config(geometry,\$maingeom\$) [list $x $y]
}

proc Fx:Reconfigure {} {
    after idle {
	global fx_config fx_rootx fx_rooty

        update
        update idletasks
	if {![info exists fx_config(geometry,\$maingeom\$)]} {
	    Fx:Configure
	    bind . <Configure> {Fx:Configure}
	}
	set fx_rootx [lindex $fx_config(geometry,\$maingeom\$) 0]
	set fx_rooty [lindex $fx_config(geometry,\$maingeom\$) 1]
	wm minsize . [winfo reqwidth .] [winfo reqheight .]
	wm maxsize . [winfo reqwidth .] [winfo reqheight .]
	if {$fx_rootx == 0 && $fx_rooty == 0} {
	    set fx_rootx [expr [winfo screenwidth .]/2 - [winfo reqwidth .]/2]
	    set fx_rooty [expr [winfo screenheight .]/2 - [winfo reqheight .]/2]
	}
        wm geometry . [winfo reqwidth .]x[winfo reqheight .]+$fx_rootx+$fx_rooty
        wm deiconify .
    }
}

if {[info exists fx_debug] && $fx_debug == 1} {
    puts "auto-loaded fx_script.tcl"
}


;# [USER-INSERTED CODE]

	lappend auto_path QBIB_LIBRARY_DIR
	Qbib:Init       ;# Load up init.tcl

;# [END USER-INSERTED CODE]
set qddbscript(schema) [Fx:Prologue qbib {} "QBIB_LIBRARY_DIR/qbib.gif" "QBIB_LIBRARY_DIR/qbib.xbm" "Qbib Version $qbib_version"]
set qddbscript_frame .fx.f0
;# [USER-INSERTED CODE]
Qbib:PostPrologue
;# [END USER-INSERTED CODE]
set qddbscript_frame .fx.f0
;# [USER-INSERTED CODE]
Qbib:PreMenubar
;# [END USER-INSERTED CODE]
Fx_Menubar menubar -w .menubar -schema \
	$qddbscript(schema) -array gv_attr -config_dir \
	.qbib_config -restrict $qddbscript(trans_name)
set qddbscript(search_entry) [menubar SearchForEntry]
frame .fx; pack .fx -side top -expand on -fill both
frame .fx.f0; pack .fx.f0 -side top -expand on -fill both
set qddbscript_frame .fx.f0
;# [USER-INSERTED CODE]
Qbib:PostMenubar
;# [END USER-INSERTED CODE]
frame .fx.f0.f0 ; pack .fx.f0.f0 -side top -expand on -fill both
.fx.f0.f0 configure -relief groove -bd 3
pack .fx.f0.f0 -expand on -fill x -side top  
frame .fx.f0.f0.f0 ; pack .fx.f0.f0.f0 -side top -expand on -fill both
Fx_Entry =EntryKey -w .fx.f0.f0.f0.e0 -attr EntryKey -setschema $qddbscript(schema) \
	 -searchfor_entry $qddbscript(search_entry) -side left -type Entry -width 16 
.fx.f0.f0.f0.e0 configure -relief flat -bd 0
pack .fx.f0.f0.f0.e0 -expand on -fill x -side left  
Fx_Entry =EntryNumber -w .fx.f0.f0.f0.e1 -attr EntryNumber \
	-side left -type Entry -width 8 
.fx.f0.f0.f0.e1 configure -relief flat -bd 0
pack .fx.f0.f0.f0.e1 -expand on -fill x -side left  
set qddbscript_frame .fx.f0.f0.f0
;# [USER-INSERTED CODE]

		bind [=EntryKey GetEntry] <KeyPress-Escape> {
		    Qbib:GenerateUniqueKey [menubar cget -schema] EntryKey
		}
		=EntryNumber configure -userconfig 0 -read_only 1
	
;# [END USER-INSERTED CODE]
Fx_Entry =EntryType -w .fx.f0.f0.f0.e2 -attr EntryType \
	-side left -type Entry -width 16 
.fx.f0.f0.f0.e2 configure -relief flat -bd 0
pack .fx.f0.f0.f0.e2 -expand on -fill x -side left  
Fx_Entry =EntryDate -w .fx.f0.f0.f0.e3 -attr EntryDate \
	-side left -type Entry -width 10 
.fx.f0.f0.f0.e3 configure -relief flat -bd 0
.fx.f0.f0.f0.e3.f_0.l configure -text {Entry date}
pack .fx.f0.f0.f0.e3 -expand on -fill x -side left  
set qddbscript_frame .fx.f0.f0.f0
;# [USER-INSERTED CODE]

		# special handling for BibTeX entry types
		=EntryType configure -read_only 1
		set qbib_entry [=EntryType cget -w]
		image create photo qbib_down -file $qddb_library/fx/pixmaps/down.gif
		button $qbib_entry.f_0.img -image qbib_down -justify c
		set buttoncmd  [list eval tk_popup $qbib_entry.f_0.menu \
			{[expr [winfo rootx %W]]} \
			{[expr [winfo rooty %W] + [winfo height %W]]}]
		bind $qbib_entry.f_0.img <ButtonRelease-1> "$buttoncmd; Qbib:UnsetMandatory"
		bind $qbib_entry.f_0.img <space> "$buttoncmd; Qbib:UnsetMandatory"
		bind $qbib_entry.f_0.img <Return> "$buttoncmd; Qbib:UnsetMandatory"
		bind $qbib_entry.f_0.img <FocusIn> {=EntryType ReFocus}
		menu $qbib_entry.f_0.menu -tearoff 0 -postcommand {set qbib_posted 1}
		bind $qbib_entry.f_0.menu <Escape> {
		    %W unpost
		    Qbib:ResetMandatory
		    set qbib_posted 0
		}
		foreach i $qbib_types {
		    $qbib_entry.f_0.menu add command -label $i -command "
		        set gv_attr(EntryType) $i
		        Qbib:ResetMandatory
		        set qbib_posted 0
		    "
		}
		pack $qbib_entry.f_0.img -side left -padx 0 -pady 0 -ipadx 0 -ipady 0
	
;# [END USER-INSERTED CODE]
frame .fx.f0.f0.f5 ; pack .fx.f0.f0.f5 -side top -expand on -fill x
.fx.f0.f0.f5 configure -relief flat -bd 0
Fx_Entry =QBtitle -w .fx.f0.f0.f5.t5 -attr QBtitle \
	-side left -type Text -width 60 -height 4 
.fx.f0.f0.f5.t5 configure -relief flat -bd 0
pack .fx.f0.f0.f5.t5 -expand on -fill x -side left  
frame .fx.f0.f0.f7 ; pack .fx.f0.f0.f7 -side top -expand on -fill x
.fx.f0.f0.f7 configure -relief flat -bd 0
Fx_Entry =QBbooktitle -w .fx.f0.f0.f7.e7 -attr QBbooktitle \
	-side left -type Entry -width 40 
.fx.f0.f0.f7.e7 configure -relief flat -bd 0
pack .fx.f0.f0.f7.e7 -expand on -fill x -side left  
Fx_Entry =QBkeywords -w .fx.f0.f0.f7.e8 -attr QBkeywords \
	-side left -type Entry -width 20 
.fx.f0.f0.f7.e8 configure -relief flat -bd 0
pack .fx.f0.f0.f7.e8 -expand on -fill x -side left  
frame .fx.f2 ; pack .fx.f2 -side top -expand on -fill x
.fx.f2 configure -relief flat -bd 0
Fx_Frame =QBauthor -w .fx.f2.f2 -side top -attr QBauthor -setschema $qddbscript(schema) 
.fx.f2.f2 configure -relief groove -bd 3
pack .fx.f2.f2 -expand on -fill x -side top  
frame .fx.f2.f2.f1 ; pack .fx.f2.f2.f1 -side top -expand on -fill both
Fx_Entry =QBauthor.Number -w .fx.f2.f2.f1.e9 -attr QBauthor.Number \
	-side left -type Entry -width 3 
.fx.f2.f2.f1.e9 configure -relief flat -bd 0
pack .fx.f2.f2.f1.e9 -expand off -fill none -side left  
=QBauthor configure -focus [=QBauthor.Number GetEntry]
set qddbscript_frame .fx.f2.f2.f1
;# [USER-INSERTED CODE]
=QBauthor.Number configure -read_only 1 -userconfig 0
;# [END USER-INSERTED CODE]
Fx_Entry =QBauthor.First -w .fx.f2.f2.f1.e10 -attr QBauthor.First \
	-side left -type Entry -width 15 
.fx.f2.f2.f1.e10 configure -relief flat -bd 0
pack .fx.f2.f2.f1.e10 -expand off -fill none -side left  
Fx_Entry =QBauthor.Middle -w .fx.f2.f2.f1.e11 -attr QBauthor.Middle \
	-side left -type Entry -width 10 
.fx.f2.f2.f1.e11 configure -relief flat -bd 0
pack .fx.f2.f2.f1.e11 -expand off -fill none -side left  
Fx_Entry =QBauthor.Last -w .fx.f2.f2.f1.e12 -attr QBauthor.Last \
	-side left -type Entry -width 10 
.fx.f2.f2.f1.e12 configure -relief flat -bd 0
pack .fx.f2.f2.f1.e12 -expand on -fill x -side left  
set qddbscript_frame .fx.f2.f2.f1
;# [USER-INSERTED CODE]

	=QBauthor configure -afteradd {
	    set gv_attr(QBauthor.Number) [qddb_instance maxnum $view QBauthor]
	} -afterdelete {
	    set max [qddb_instance maxnum $view QBauthor]
	    for {set i 1} {$i <= $max} {incr i} {
		qddb_instance switch $view QBauthor $i
		set gv_attr(QBauthor.Number) $i
	    }
	}
	
;# [END USER-INSERTED CODE]
frame .fx.f2.f3 ; pack .fx.f2.f3 -side top -expand on -fill both
.fx.f2.f3 configure -relief groove -bd 3
pack .fx.f2.f3 -expand on -fill x -side top  
frame .fx.f2.f3.f2 ; pack .fx.f2.f3.f2 -side top -expand on -fill both
NoteBook .fx.f2.f3.f2.nb0 -bd 2
pack .fx.f2.f3.f2.nb0 -side top -expand on -fill x
pack .fx.f2.f3.f2.nb0 -expand on -fill x -side left  
.fx.f2.f3.f2.nb0 insert end tab0 -text {Publication Information}
frame [.fx.f2.f3.f2.nb0 getframe tab0].f1 ; pack [.fx.f2.f3.f2.nb0 getframe tab0].f1 -side top -expand on -fill both
Fx_Entry =QBjournal -w [.fx.f2.f3.f2.nb0 getframe tab0].f1.e1 -attr QBjournal \
	-side left -type Entry -width 40 
[.fx.f2.f3.f2.nb0 getframe tab0].f1.e1 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f1.e1 -expand on -fill x -side left  
Fx_Entry =QBpublisher -w [.fx.f2.f3.f2.nb0 getframe tab0].f1.e2 -attr QBpublisher \
	-side left -type Entry -width 20 
[.fx.f2.f3.f2.nb0 getframe tab0].f1.e2 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f1.e2 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab0].f4 ; pack [.fx.f2.f3.f2.nb0 getframe tab0].f4 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab0].f4 configure -relief flat -bd 0
Fx_Entry =QBorganization -w [.fx.f2.f3.f2.nb0 getframe tab0].f4.e4 -attr QBorganization \
	-side left -type Entry -width 20 
[.fx.f2.f3.f2.nb0 getframe tab0].f4.e4 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f4.e4 -expand on -fill x -side left  
Fx_Entry =QBinstitution -w [.fx.f2.f3.f2.nb0 getframe tab0].f4.e5 -attr QBinstitution \
	-side left -type Entry -width 20 
[.fx.f2.f3.f2.nb0 getframe tab0].f4.e5 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f4.e5 -expand on -fill x -side left  
Fx_Entry =QBschool -w [.fx.f2.f3.f2.nb0 getframe tab0].f4.e6 -attr QBschool \
	-side left -type Entry -width 20 
[.fx.f2.f3.f2.nb0 getframe tab0].f4.e6 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f4.e6 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab0].f8 ; pack [.fx.f2.f3.f2.nb0 getframe tab0].f8 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab0].f8 configure -relief flat -bd 0
Fx_Entry =QBeditor -w [.fx.f2.f3.f2.nb0 getframe tab0].f8.e8 -attr QBeditor \
	-side left -type Entry -width 35 
[.fx.f2.f3.f2.nb0 getframe tab0].f8.e8 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f8.e8 -expand on -fill x -side left  
Fx_Entry =QBhowpublished -w [.fx.f2.f3.f2.nb0 getframe tab0].f8.e9 -attr QBhowpublished \
	-side left -type Entry -width 25 
[.fx.f2.f3.f2.nb0 getframe tab0].f8.e9 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f8.e9 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab0].f11 ; pack [.fx.f2.f3.f2.nb0 getframe tab0].f11 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab0].f11 configure -relief flat -bd 0
Fx_Entry =QBaddress -w [.fx.f2.f3.f2.nb0 getframe tab0].f11.t11 -attr QBaddress \
	-side left -type Text -width 10 -height 4 
[.fx.f2.f3.f2.nb0 getframe tab0].f11.t11 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f11.t11 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab0].f13 ; pack [.fx.f2.f3.f2.nb0 getframe tab0].f13 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab0].f13 configure -relief flat -bd 0
Fx_Entry =QBchapter -w [.fx.f2.f3.f2.nb0 getframe tab0].f13.e13 -attr QBchapter \
	-side left -type Entry -width 20 
[.fx.f2.f3.f2.nb0 getframe tab0].f13.e13 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f13.e13 -expand on -fill x -side left  
Fx_Entry =QBedition -w [.fx.f2.f3.f2.nb0 getframe tab0].f13.e14 -attr QBedition \
	-side left -type Entry -width 20 
[.fx.f2.f3.f2.nb0 getframe tab0].f13.e14 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f13.e14 -expand on -fill x -side left  
Fx_Entry =QBseries -w [.fx.f2.f3.f2.nb0 getframe tab0].f13.e15 -attr QBseries \
	-side left -type Entry -width 20 
[.fx.f2.f3.f2.nb0 getframe tab0].f13.e15 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f13.e15 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab0].f17 ; pack [.fx.f2.f3.f2.nb0 getframe tab0].f17 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab0].f17 configure -relief flat -bd 0
Fx_Entry =QBvolume -w [.fx.f2.f3.f2.nb0 getframe tab0].f17.e17 -attr QBvolume \
	-side left -type Entry -width 15 
[.fx.f2.f3.f2.nb0 getframe tab0].f17.e17 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f17.e17 -expand on -fill x -side left  
Fx_Entry =QBnumber -w [.fx.f2.f3.f2.nb0 getframe tab0].f17.e18 -attr QBnumber \
	-side left -type Entry -width 15 
[.fx.f2.f3.f2.nb0 getframe tab0].f17.e18 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f17.e18 -expand on -fill x -side left  
Fx_Entry =QBmonth -w [.fx.f2.f3.f2.nb0 getframe tab0].f17.e19 -attr QBmonth \
	-side left -type Entry -width 15 
[.fx.f2.f3.f2.nb0 getframe tab0].f17.e19 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f17.e19 -expand on -fill x -side left  
Fx_Entry =QByear -w [.fx.f2.f3.f2.nb0 getframe tab0].f17.e20 -attr QByear \
	-side left -type Entry -width 15 
[.fx.f2.f3.f2.nb0 getframe tab0].f17.e20 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f17.e20 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab0].f22 ; pack [.fx.f2.f3.f2.nb0 getframe tab0].f22 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab0].f22 configure -relief flat -bd 0
Fx_Entry =QBpages -w [.fx.f2.f3.f2.nb0 getframe tab0].f22.e22 -attr QBpages \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab0].f22.e22 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f22.e22 -expand on -fill x -side left  
Fx_Entry =QBkey -w [.fx.f2.f3.f2.nb0 getframe tab0].f22.e23 -attr QBkey \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab0].f22.e23 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f22.e23 -expand on -fill x -side left  
Fx_Entry =QBtype -w [.fx.f2.f3.f2.nb0 getframe tab0].f22.e24 -attr QBtype \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab0].f22.e24 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f22.e24 -expand on -fill x -side left  
Fx_Entry =QBcrossref -w [.fx.f2.f3.f2.nb0 getframe tab0].f22.e25 -attr QBcrossref \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab0].f22.e25 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab0].f22.e25 -expand on -fill x -side left  
.fx.f2.f3.f2.nb0 insert end tab1 -text Reviews/Comments
frame [.fx.f2.f3.f2.nb0 getframe tab1].f27 ; pack [.fx.f2.f3.f2.nb0 getframe tab1].f27 -side top -expand on -fill both
Fx_Frame =MiscComments -w [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27 -attr MiscComments -side top 
[.fx.f2.f3.f2.nb0 getframe tab1].f27.f27 configure -relief groove -bd 3
pack [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27 -expand on -fill x -side top  
frame [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0 ; pack [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0 -side top -expand on -fill both
Fx_Entry =MiscComments.Name -w [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0.e0 -attr MiscComments.Name \
	-side left -type Entry -width 25 
[.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0.e0 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0.e0 -expand on -fill x -side left  
=MiscComments configure -focus [=MiscComments.Name GetEntry]
Fx_Entry =MiscComments.Email -w [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0.e1 -attr MiscComments.Email \
	-side left -type Entry -width 25 
[.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0.e1 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0.e1 -expand on -fill x -side left  
Fx_Entry =MiscComments.Date -w [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0.e2 -attr MiscComments.Date \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0.e2 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f0.e2 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f4 ; pack [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f4 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f4 configure -relief flat -bd 0
Fx_Entry =MiscComments.Subject -w [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f4.e4 -attr MiscComments.Subject \
	-side left -type Entry -width 50 
[.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f4.e4 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f4.e4 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f6 ; pack [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f6 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f6 configure -relief flat -bd 0
Fx_Entry =MiscComments.Comment -w [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f6.t6 -attr MiscComments.Comment \
	-side left -type Text -width 10 -height 8 
[.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f6.t6 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab1].f27.f27.f6.t6 -expand on -fill x -side left  
.fx.f2.f3.f2.nb0 insert end tab2 -text Abstract
frame [.fx.f2.f3.f2.nb0 getframe tab2].f29 ; pack [.fx.f2.f3.f2.nb0 getframe tab2].f29 -side top -expand on -fill both
Fx_Entry =QBabstract -w [.fx.f2.f3.f2.nb0 getframe tab2].f29.t29 -attr QBabstract \
	-side left -type Text -width 60 -height 12 
[.fx.f2.f3.f2.nb0 getframe tab2].f29.t29 configure -relief flat -bd 0
[.fx.f2.f3.f2.nb0 getframe tab2].f29.t29.f_0.l configure -width 9
pack [.fx.f2.f3.f2.nb0 getframe tab2].f29.t29 -expand on -fill x -side left  
set qddbscript_frame [.fx.f2.f3.f2.nb0 getframe tab2].f29
;# [USER-INSERTED CODE]
pack [=QBabstract cget -w].f_0 -anchor nw
;# [END USER-INSERTED CODE]
.fx.f2.f3.f2.nb0 insert end tab3 -text Annotation/Notes
frame [.fx.f2.f3.f2.nb0 getframe tab3].f31 ; pack [.fx.f2.f3.f2.nb0 getframe tab3].f31 -side top -expand on -fill both
Fx_Entry =QBannote -w [.fx.f2.f3.f2.nb0 getframe tab3].f31.t31 -attr QBannote \
	-side left -type Text -width 10 -height 6 
[.fx.f2.f3.f2.nb0 getframe tab3].f31.t31 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab3].f31.t31 -expand on -fill x -side left  
set qddbscript_frame [.fx.f2.f3.f2.nb0 getframe tab3].f31
;# [USER-INSERTED CODE]
pack [=QBannote cget -w].f_0 -anchor nw
;# [END USER-INSERTED CODE]
frame [.fx.f2.f3.f2.nb0 getframe tab3].f33 ; pack [.fx.f2.f3.f2.nb0 getframe tab3].f33 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab3].f33 configure -relief flat -bd 0
Fx_Entry =QBnote -w [.fx.f2.f3.f2.nb0 getframe tab3].f33.t33 -attr QBnote \
	-side left -type Text -width 10 -height 6 
[.fx.f2.f3.f2.nb0 getframe tab3].f33.t33 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab3].f33.t33 -expand on -fill x -side left  
set qddbscript_frame [.fx.f2.f3.f2.nb0 getframe tab3].f33
;# [USER-INSERTED CODE]
pack [=QBnote cget -w].f_0 -anchor nw
;# [END USER-INSERTED CODE]
.fx.f2.f3.f2.nb0 insert end tab4 -text Miscellaneous
frame [.fx.f2.f3.f2.nb0 getframe tab4].f35 ; pack [.fx.f2.f3.f2.nb0 getframe tab4].f35 -side top -expand on -fill both
Fx_Entry =QBurl -w [.fx.f2.f3.f2.nb0 getframe tab4].f35.e35 -attr QBurl \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab4].f35.e35 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab4].f35.e35 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab4].f37 ; pack [.fx.f2.f3.f2.nb0 getframe tab4].f37 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab4].f37 configure -relief flat -bd 0
Fx_Entry =QBisbn -w [.fx.f2.f3.f2.nb0 getframe tab4].f37.e37 -attr QBisbn \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab4].f37.e37 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab4].f37.e37 -expand on -fill x -side left  
Fx_Entry =QBissn -w [.fx.f2.f3.f2.nb0 getframe tab4].f37.e38 -attr QBissn \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab4].f37.e38 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab4].f37.e38 -expand on -fill x -side left  
Fx_Entry =QBlccn -w [.fx.f2.f3.f2.nb0 getframe tab4].f37.e39 -attr QBlccn \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab4].f37.e39 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab4].f37.e39 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab4].f41 ; pack [.fx.f2.f3.f2.nb0 getframe tab4].f41 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab4].f41 configure -relief flat -bd 0
Fx_Entry =QBcopyright -w [.fx.f2.f3.f2.nb0 getframe tab4].f41.e41 -attr QBcopyright \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab4].f41.e41 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab4].f41.e41 -expand on -fill x -side left  
Fx_Entry =QBlanguage -w [.fx.f2.f3.f2.nb0 getframe tab4].f41.e42 -attr QBlanguage \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab4].f41.e42 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab4].f41.e42 -expand on -fill x -side left  
Fx_Entry =QBprice -w [.fx.f2.f3.f2.nb0 getframe tab4].f41.e43 -attr QBprice \
	-side left -type Entry -width 10 
[.fx.f2.f3.f2.nb0 getframe tab4].f41.e43 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab4].f41.e43 -expand off -fill none -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab4].f45 ; pack [.fx.f2.f3.f2.nb0 getframe tab4].f45 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab4].f45 configure -relief flat -bd 0
Fx_Entry =QBcontents -w [.fx.f2.f3.f2.nb0 getframe tab4].f45.t45 -attr QBcontents \
	-side left -type Text -width 10 -height 4 
[.fx.f2.f3.f2.nb0 getframe tab4].f45.t45 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab4].f45.t45 -expand on -fill x -side left  
frame [.fx.f2.f3.f2.nb0 getframe tab4].f47 ; pack [.fx.f2.f3.f2.nb0 getframe tab4].f47 -side top -expand on -fill x
[.fx.f2.f3.f2.nb0 getframe tab4].f47 configure -relief flat -bd 0
Fx_Entry =QBcomments -w [.fx.f2.f3.f2.nb0 getframe tab4].f47.t47 -attr QBcomments \
	-side left -type Text -width 10 -height 4 
[.fx.f2.f3.f2.nb0 getframe tab4].f47.t47 configure -relief flat -bd 0
pack [.fx.f2.f3.f2.nb0 getframe tab4].f47.t47 -expand on -fill x -side left  
.fx.f2.f3.f2.nb0 raise tab0
.fx.f2.f3.f2.nb0 compute_size
Fx:Epilogue
	[=EntryKey cget -w].f_0.l configure -width 15
	[=QBtitle cget -w].f_0.l configure -width 15
	[=QBbooktitle cget -w].f_0.l configure -width 15
	[=QBauthor.Number cget -w].f_0.l configure -width 15
	[=QBjournal cget -w].f_0.l configure -width 15
	[=QBorganization cget -w].f_0.l configure -width 15
	[=QBeditor cget -w].f_0.l configure -width 15
	[=QBaddress cget -w].f_0.l configure -width 15
	[=QBchapter cget -w].f_0.l configure -width 15
	[=QBvolume cget -w].f_0.l configure -width 15
	[=QBpages cget -w].f_0.l configure -width 15
	[=MiscComments.Name cget -w].f_0.l configure -width 15
	[=MiscComments.Subject cget -w].f_0.l configure -width 15
	[=MiscComments.Comment cget -w].f_0.l configure -width 15
	[=QBannote cget -w].f_0.l configure -width 15
	[=QBnote cget -w].f_0.l configure -width 15
	[=QBurl cget -w].f_0.l configure -width 15
	[=QBisbn cget -w].f_0.l configure -width 15
	[=QBcopyright cget -w].f_0.l configure -width 15
	[=QBcontents cget -w].f_0.l configure -width 15
	[=QBcomments cget -w].f_0.l configure -width 15

