#!/bin/sh
DISABLE_SHARED=--disable-shared
#DISABLE_SHARED=

TCLNUM=tcl8.4.9
TKNUM=tk8.4.9
#-------------------
if test "x$TCL_SYMBOLS" = "x"; then
	TCL_SYMBOLS=--disable-symbols
fi
if test "x$TK_SYMBOLS" = "x"; then
	TK_SYMBOLS=--disable-symbols
fi

if test "x$TCL_NAME" = "x"; then
	TCL_NAME=tcl8.4
fi
TCL=`pwd`/../../qddb/$TCL_NAME
rm -f $TCL
ln -s `pwd`/../../qddb/$TCLNUM $TCL 
if test "x$TK_NAME" = "x"; then
	TK_NAME=tk8.4
fi
TK=`pwd`/../../qddb/$TK_NAME
rm -f $TK
ln -s `pwd`/../../qddb/$TKNUM $TK
if test "x$ITCL_NAME" = "x"; then
	ITCL_NAME=itcl3.2.1
fi
ITCL=`pwd`/../../qddb/$ITCL_NAME
if test "x$ITK_NAME" = "x"; then
	ITK_NAME=itk3.2.1
fi
if test "x$BLT_NAME" = "x"; then
	BLT_NAME=blt2.4z
fi
BLT=`pwd`/../../qddb/$BLT_NAME
if test "x$THREADS_NAME" = "x"; then
	THREADS_NAME=thread-2.5.2
fi
THREADS=`pwd`/../../qddb/$THREADS_NAME
if test "x$BWIDGET_NAME" = "x"; then
	BWIDGET_NAME=BWidget-1.7.0
fi
BWIDGET=`pwd`/../../qddb/$BWIDGET_NAME
if test "x$QDDB_NAME" = "x"; then
	QDDB_NAME=qddb
fi
QDDB=`pwd`/../../qddb/$QDDB_NAME

lib=$PREFIX/lib/qddb
sh ./mkdirhier $lib

mkdir $TCL_NAME
mkdir $TCL_NAME/unix
mkdir $TK_NAME
mkdir $TK_NAME/unix
mkdir $ITCL_NAME
mkdir $ITCL_NAME/itcl
mkdir $ITCL_NAME/itcl/unix
mkdir $ITCL_NAME/itk
mkdir $ITCL_NAME/itk/unix
mkdir $ITCL_NAME/iwidgets2.2.0
mkdir $ITCL_NAME/iwidgets2.2.0/unix
mkdir $ITCL_NAME/iwidgets3.0.0
mkdir $ITCL_NAME/iwidgets3.0.0/unix

cd $TCL_NAME/unix
$TCL/unix/configure --prefix=$lib $DISABLE_SHARED $ENABLE_THREADS \
	--program-suffix=-qddb $TCL_SYMBOLS
$MAKE
$MAKE install
cd ../..
cd $TK_NAME/unix
$TK/unix/configure --prefix=$lib $DISABLE_SHARED $ENABLE_THREADS \
	--program-suffix=-qddb $TK_SYMBOLS
$MAKE
$MAKE install
cd ../..

cd $ITCL_NAME
$ITCL/configure --prefix="$lib" --host="$HOST" $DISABLE_SHARED $ENABLE_THREADS
$MAKE
$MAKE install
cd ..

mkdir $BLT_NAME
cd $BLT_NAME
$BLT/configure --prefix="$lib" --with-tcl="$lib" \
	--with-tk="$lib" --with-cc="$CC" --with-cflags="$CFLAGS" \
	$DISABLE_SHARED $ENABLE_THREADS
$MAKE
$MAKE install
cd ..

mkdir $BWIDGET_NAME
cd $BWIDGET_NAME
$BWIDGET/configure --prefix="$lib"
$MAKE
$MAKE install
cd ..

#mkdir $THREADS_NAME
#cd $THREADS_NAME
#$THREADS/configure --prefix="$lib" --with-tcl="$lib"
#$MAKE
#$MAKE install
#cd ..

ITCL_NAME=itcl3.2
ITK_NAME=itk3.2
if [ -f $lib/lib/lib${TK_NAME}.a ]; then
	TK_INCLUDE_DIR=$lib/include
	TK_LIBRARY_DIR=$lib/lib
	TK_LIBRARY_NAME=$TK_NAME
	TCL_INCLUDE_DIR=$lib/include
	TCL_LIBRARY_DIR=$lib/lib
	TCL_LIBRARY_NAME=$TCL_NAME
	ITCL_LIBRARY_DIR=$lib/lib
	ITCL_LIBRARY_NAME=$ITCL_NAME
	ITK_LIBRARY_DIR=$lib/lib
	ITK_LIBRARY_NAME=$ITK_NAME
	BLT_LIBRARY_DIR=$lib/lib
	BLT_LIBRARY_NAME=BLT
else
	TK_INCLUDE_DIR=$lib/include
	TK_LIBRARY_DIR=$lib/lib
	TK_LIBRARY_NAME=`echo $TK_NAME | sed -e 's/\.//'`
	TCL_INCLUDE_DIR=$lib/include
	TCL_LIBRARY_DIR=$lib/lib
	TCL_LIBRARY_NAME=`echo $TCL_NAME | sed -e 's/\.//'`
	ITCL_LIBRARY_DIR=$lib/lib
	ITCL_LIBRARY_NAME=`echo $ITCL_NAME | sed -e 's/\.//'`
	ITK_LIBRARY_DIR=$lib/lib
	ITK_LIBRARY_NAME=`echo $ITK_NAME | sed -e 's/\.//'`
	BLT_LIBRARY_DIR=$lib/lib
	BLT_LIBRARY_NAME=BLT
fi
export TCL_INCLUDE_DIR TCL_LIBRARY_DIR TCL_LIBRARY_NAME 
export TK_INCLUDE_DIR TK_LIBRARY_DIR TK_LIBRARY_NAME
export ITCL_LIBRARY_DIR ITCL_LIBRARY_NAME ITK_LIBRARY_DIR ITK_LIBRARY_NAME
export BLT_LIBRARY_DIR BLT_LIBRARY_NAME
mkdir $QDDB_NAME
cd $QDDB_NAME
$QDDB/configure --prefix=$PREFIX --libdir=$lib/lib \
	--with-tk --with-itcl --with-blt \
	--enable-maxmem=65536 
$MAKE
$MAKE install
exit 0

