
/* $RCSfile: Qddb_Index.h,v $ $Revision: 2.0.0.1 $ $Date: 2000/11/09 15:05:57 $
 *
 * Copyright (C) 1993-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#if !defined(_QDDB_INDEX_H_)
#define _QDDB_INDEX_H_

typedef struct qddb_pnode {
    off_t		Start;
    size_t		Length, attr;
    char		*inst;
    struct qddb_pnode	*next;
} Qddb_PosNode;

typedef struct qddb_knode {
    char		*s;
    Qddb_PosNode	*pos;
    int			len;
    size_t		attr;
    char		*inst;
    struct qddb_knode	*next;
} Qddb_KeyNode;

typedef struct kindex {
    char		*s;
    off_t		Start;
    size_t		Length;
} Qddb_KeyIndexIn;

typedef struct nindex {
    double		s;
    off_t		Start;
    size_t		Length;
} Qddb_NumericIndexIn;

typedef Qddb_KeyNode	*Qddb_Bucket;

/* Lib/LibQddb/BuildDB.c */
void Qddb_BuildDatabase _ANSI_ARGS_((Qddb_Schema *));
void Qddb_WriteReducedAttributeIdentifiers _ANSI_ARGS_((Qddb_Schema *));
void Qddb_BuildReducedAttributeTable _ANSI_ARGS_((Qddb_Schema *, char *));

/* Lib/LibQddb/MakeKeys.c */
void Qddb_MakeKeys _ANSI_ARGS_((Qddb_Schema *));

/* Lib/LibQddb/Index.c */
void Qddb_MakeIndex _ANSI_ARGS_((Qddb_Schema *, Qddb_Boolean));
Qddb_KeyNode *Qddb_IndexParse _ANSI_ARGS_((Qddb_Schema *, Qddb_Entry, int *));

#endif

