
/* $RCSfile: Qddb_Memory.h,v $ $Revision: 2.0.0.1 $ $Date: 2000/11/09 15:05:57 $
 *
 * Copyright (C) 1993-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#if !defined(_QDDB_MEMORY_H_)
#define _QDDB_MEMORY_H_

#if defined(DEBUG_MALLOC)
#include "/usr/local/include/dmalloc.h"
#undef USE_MALLOC_FUNCTIONS
#else
#define USE_MALLOC_FUNCTIONS
#endif

#if defined(USE_MALLOC_FUNCTIONS)
char 			*Malloc _ANSI_ARGS_((size_t));
char 			*Calloc _ANSI_ARGS_((size_t));
char 			*Realloc _ANSI_ARGS_((void *, size_t));
void			Free _ANSI_ARGS_((void *));
#else
#define Malloc(x)	malloc(x > 0? x:QDDB_MIN_MALLOC_SIZE), qddb_malloc_bytes_used += x
#define Calloc(x)	calloc(x > 0? x:QDDB_MIN_MALLOC_SIZE,1), qddb_malloc_bytes_used += x
#define Realloc(x,y)	realloc(x, y > 0? y:QDDB_MIN_MALLOC_SIZE)
#define Free(x)		if (x != NULL) free(x)
#endif

#if !defined(USE_GNU_MALLOC)
extern size_t		qddb_malloc_bytes_used;
#endif

/* Allocated memory types. 
 */
#define QDDB_TYPE_INCOREENTRY	      1
#define QDDB_TYPE_KEYLIST	      2
#define QDDB_TYPE_ROWLIST	      3
#define QDDB_TYPE_DATATREE	      4
#define QDDB_TYPE_SCHEMATREE	      5
#define QDDB_TYPE_ENTRY		      6
#define QDDB_TYPE_SCHEMA	      7
#define QDDB_TYPE_GENERIC	      8
#define QDDB_TYPE_DOUBLELIST	      9
#define QDDB_TYPE_TABLECALC	      10
#define QDDB_TYPE_TABLEREFS	      11
#define QDDB_TYPE_WORDLIST	      12
#define QDDB_TYPE_ATTRLIST            13
#define QDDB_TYPE_QDDBSCRIPTCELL      14
#define QDDB_TYPE_QDDBSCRIPTATTRSTACK 15

#define QDDB_MIN_MALLOC_SIZE	16

void			Qddb_Free _ANSI_ARGS_((int, void *));

#endif




