
/* $RCSfile: Qddb_Postscript.h,v $ $Revision: 2.1 $ $Date: 2003/03/23 17:16:14 $
 *
 * Copyright (C) 1997-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#if !defined(_QDDB_POSTSCRIPT_H_)
#define _QDDB_POSTSCRIPT_H_

/* Miscellaneous defaults and settings
 */
#define QDDB_POSTSCRIPT_TAB_WIDTH 8
#define QDDB_POSTSCRIPT_LINES_PER_PAGE 66
#define QDDB_POSTSCRIPT_CHARS_PER_INCH 12

#define QDDB_POSTSCRIPT_PAGE_LENGTH_A4 842.0
#define QDDB_POSTSCRIPT_PAGE_LENGTH_LETTER 792.0
#define QDDB_POSTSCRIPT_PAGE_LENGTH_LEGAL 1008.0

#define QDDB_POSTSCRIPT_BASELINE_OFFSET 30.0
#define QDDB_POSTSCRIPT_VERTICAL_SPACING 11.5
#define QDDB_POSTSCRIPT_LEFT_MARGIN 36.0
#define QDDB_POSTSCRIPT_FONT "Courier"
#define QDDB_POSTSCRIPT_BOLD_FONT "Courier-Bold"

#define QDDB_POSTSCRIPT_ORIENT_PORTRAIT 0
#define QDDB_POSTSCRIPT_ORIENT_LANDSCAPE 1

typedef struct {
    int        lines_per_page;
    int        tab_width_chars;
    int        orient;
    char       *font;
    char       *bold_font;
    double     chars_per_inch;
    double     page_length_pts;
    double     baseline_offset_pts;
    double     vertical_spacing_pts;
    double     left_margin_pts;
    double     char_width_pts;
} Qddb_PostscriptOptions;

char *Qddb_TextToPostscript _ANSI_ARGS_((CONST char *, Qddb_PostscriptOptions *));
#endif

