
/* $RCSfile: Qddb_Regexp.h,v $ $Revision: 2.0.0.1 $ $Date: 2000/11/09 15:05:57 $
 *
 * Copyright (C) 1997-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


/*
 * Definitions etc. for regexp(3) routines.
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */

#if !defined(_QDDB_REGEXP_H_)
#define _QDDB_REGEXP_H_

#define QDDB_REGEXP_NSUBEXP  10

/*
 * The first byte of the regexp internal "program" is actually this magic
 * number; the start node begins in the second byte.
 */
#define	QDDB_REGEXP_MAGIC	0234

/* CHARBITS=0377	compilers that don't do unsigned char
 */
#if defined(QDDB_REGEXP_CHARBITS)
#undef QDDB_REGEXP_CHARBITS
#endif
#define QDDB_REGEXP_CHARBITS 0377

typedef struct Qddb_Regexp {
	char 		*startp[QDDB_REGEXP_NSUBEXP];
	char 		*endp[QDDB_REGEXP_NSUBEXP];
	char 		regstart;		/* Internal use only. */
	char 		reganch;		/* Internal use only. */
	char 		*regmust;		/* Internal use only. */
	int 		regmlen;		/* Internal use only. */
	char 		program[1];		/* Unwarranted chumminess with compiler. */
} Qddb_Regexp;

Qddb_Regexp *Qddb_Regcomp _ANSI_ARGS_((char *));
int Qddb_Regexec          _ANSI_ARGS_((Qddb_Regexp *, char *));
void Qddb_Regsub          _ANSI_ARGS_((Qddb_Regexp *, char *, char *));
void Qddb_Regerror        _ANSI_ARGS_((char *));
#endif

