
/* $RCSfile: Qddb_Rows.h,v $ $Revision: 2.0.0.1 $ $Date: 2000/11/09 15:05:57 $
 *
 * Copyright (C) 1997-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#if !defined(_QDDB_ROWS_H_)
#define _QDDB_ROWS_H_

typedef struct qddb_rl {
    int			Attribute;
    int			Flags;
    struct qddb_rl	*next; /* next one on same row */
    struct qddb_rl	*down; /* next row */
} Qddb_RowList;

/* Flags */
#define QDDB_ROWLIST_CONTAINS_TRUE  0x0001
#define QDDB_ROWLIST_CONTAINS_FALSE 0x0002

Qddb_Boolean Qddb_RowListCompareRows _ANSI_ARGS_((Qddb_InCoreEntry *, Qddb_RowList *, Qddb_RowList *, \
					     size_t *, size_t));
void         Qddb_RowListFreeRow _ANSI_ARGS_((Qddb_RowList *));
int	     Qddb_RowListShouldSkipRow _ANSI_ARGS_((Qddb_InCoreEntry *, Qddb_RowList *, size_t *, size_t));
void 	     Qddb_RowListDeleteDuplicateRows _ANSI_ARGS_((Qddb_InCoreEntry *, Qddb_RowList *, \
							  size_t *, size_t));
Qddb_RowList *Qddb_RowListProcessEntry _ANSI_ARGS_((Qddb_Schema *, Qddb_InCoreEntry *));
Qddb_RowList *Qddb_RowListProcessAttr _ANSI_ARGS_((Qddb_Schema *, Qddb_InCoreEntry *, size_t, size_t *, size_t));
Qddb_RowList *Qddb_RowListProcessInst _ANSI_ARGS_((Qddb_Schema *, Qddb_InCoreEntry *, size_t, size_t *, size_t));
Qddb_RowList *Qddb_RowListCopy _ANSI_ARGS_((Qddb_RowList *));
Qddb_RowList *Qddb_RowListCartesianProduct _ANSI_ARGS_((Qddb_RowList *, Qddb_RowList *));
Qddb_RowList *Qddb_RowListUnion _ANSI_ARGS_((Qddb_RowList *, Qddb_RowList *));
void         Qddb_RowListPruneUntrueRows _ANSI_ARGS_((Qddb_RowList **));
#if defined(USE_TCL)
int Qddb_RowListQuery _ANSI_ARGS_((Tcl_Interp *, Qddb_Schema *, Qddb_KeyList *, char *, char **, size_t *, \
				   size_t, char **, size_t, Qddb_Boolean, Qddb_Boolean, Qddb_Boolean, \
				   Qddb_Boolean, Qddb_Boolean));
#else
int Qddb_RowListQuery _ANSI_ARGS_((Qddb_Schema *, Qddb_KeyList *, char *, char **, size_t *, size_t, \
				   char **, size_t, Qddb_Boolean, Qddb_Boolean));
#endif

#endif

