
/* $RCSfile: Qddb_Script.h,v $ $Revision: 2.0.0.1 $ $Date: 2000/11/09 15:05:57 $
 *
 * Copyright (C) 1997-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#if !defined(_QDDB_SCRIPT_H_)
#define _QDDB_SCRIPT_H_

#define QDDB_SCRIPT_OPTION_FRAME        1
#define QDDB_SCRIPT_OPTION_ENTRY        2
#define QDDB_SCRIPT_OPTION_TEXT         3
#define QDDB_SCRIPT_OPTION_RADIOBUTTON  4
#define QDDB_SCRIPT_OPTION_LABEL        5
#define QDDB_SCRIPT_OPTION_NOTEBOOK     6
#define QDDB_SCRIPT_OPTION_TAB          7
#define QDDB_SCRIPT_OPTION_BREAK        8
#define QDDB_SCRIPT_OPTION_PROLOGUE     9
#define QDDB_SCRIPT_OPTION_EPILOGUE     10
#define QDDB_SCRIPT_OPTION_CODE         11
#define QDDB_SCRIPT_OPTION_MENUBAR      12
#define QDDB_SCRIPT_OPTION_OPTIONS      13

#define QDDB_SCRIPT_SIDE_LEFT           1
#define QDDB_SCRIPT_SIDE_RIGHT          2
#define QDDB_SCRIPT_SIDE_TOP            3
#define QDDB_SCRIPT_SIDE_BOTTOM         4

#define QDDB_SCRIPT_ANCHOR_W            1
#define QDDB_SCRIPT_ANCHOR_E            2
#define QDDB_SCRIPT_ANCHOR_N            3
#define QDDB_SCRIPT_ANCHOR_S            4
#define QDDB_SCRIPT_ANCHOR_NW           5
#define QDDB_SCRIPT_ANCHOR_NE           6
#define QDDB_SCRIPT_ANCHOR_SW           7
#define QDDB_SCRIPT_ANCHOR_SE           8
#define QDDB_SCRIPT_ANCHOR_CENTER       9

#define QDDB_SCRIPT_RELIEF_FLAT         1
#define QDDB_SCRIPT_RELIEF_GROOVE       2
#define QDDB_SCRIPT_RELIEF_RAISED       3
#define QDDB_SCRIPT_RELIEF_SUNKEN       4

#define QDDB_SCRIPT_LANG_TCL            1   /* currently ignored */

#define QDDB_SCRIPT_MAXFRAMEDEPTH       128

typedef struct qddb_script_attrstack {
    char                         *attr;
    size_t                       level;
    Qddb_Boolean                 isframe;
    struct qddb_script_attrstack *next;
} Qddb_ScriptAttrStack;

typedef struct qddb_script_cell {
    int                       option;
    Qddb_Boolean              endoption;
    char                      *attr;
    char                      *label;
    char                      *config;
    int                       labelwidth;
    int                       width;
    int                       height;
    int                       border;
    int                       relief;
    int                       padx;
    int                       pady;
    int                       ipadx;
    int                       ipady;
    int                       side;
    int                       labelside;
    int                       anchor;
    char                      **values;
    int                       underline;
    Qddb_Boolean              noexpand;
    char                      *bannergif;
    char                      *bannerxbm;
    char                      *bannertitle;
    int                       language;
    int                       autoalign;
    int                       linenumber;
    struct qddb_script_cell   *next;
} Qddb_ScriptCell;

int             QddbScriptParse                  _ANSI_ARGS_((void));
void            Qddb_ResetQddbScriptParser       _ANSI_ARGS_((void));
void            Qddb_ResetQddbScriptLex          _ANSI_ARGS_((void));
Qddb_ScriptCell *Qddb_GetQddbScriptParserResults _ANSI_ARGS_((void));
#endif

