
/* $RCSfile: Qddb_Search.h,v $ $Revision: 2.1 $ $Date: 2003/03/23 17:16:14 $
 *
 * Copyright (C) 1997-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#if !defined(_QDDB_SEARCH_H_)
#define _QDDB_SEARCH_H_

#define QDDB_CHUNK_SIZE	        (size_t)(32*1024)
#define QDDB_CHUNK_NOTFOUND     -1
#define QDDB_CHUNK_UNDERFLOW	-2
#define QDDB_CHUNK_OVERFLOW	-3

typedef struct {
    enum {
	REGEXP_V8, 
	NUMERIC, ALPHA, NUMERICRANGE, ALPHARANGE, ALPHAPARSE, ALPHANOPARSE
    } 			Type;
    Qddb_Regexp		*Reg;			/* Internal use */
    CONST char		*Alpha; 		/* used for Regexp and String searching */
    CONST char		*UpperStr, *LowerStr;
    double		Number;
    double		UpperNum, LowerNum;
    Qddb_Boolean	UpperExists, LowerExists;
} Qddb_SearchArg;

typedef struct {
    Qddb_Boolean	UpperExists, LowerExists;
    double		Upper, Lower;
} Qddb_NumericRange;
    
typedef struct {
    Qddb_Boolean	UpperExists, LowerExists;
    char		*Upper, *Lower;
} Qddb_StringRange;

typedef struct {
    Qddb_Boolean		used;
    off_t		start;
    size_t		length;
} Qddb_ChunkBounds;

Qddb_KeyList *Qddb_Search _ANSI_ARGS_((Qddb_Schema *, Qddb_SearchArg *, size_t *, int));

Qddb_KeyList *Qddb_ParseKey _ANSI_ARGS_((Qddb_Schema *, char *, size_t *, Qddb_Boolean, int));
Qddb_KeyList *Qddb_ParseKey2 _ANSI_ARGS_((Qddb_Schema *, char *, char **));
char    *Qddb_ConvertAttributeNumberToName _ANSI_ARGS_((Qddb_Schema *, int));
int	Qddb_ConvertAttributeNameToNumber _ANSI_ARGS_((Qddb_Schema *, CONST char *));

/* from Lib/LibQddb/Hash.c */
int 	Qddb_HashValue _ANSI_ARGS_((Qddb_Schema *, char *));
#endif
