
/* $RCSfile: Qddb_Tree.h,v $ $Revision: 2.1 $ $Date: 2003/03/23 17:16:14 $
 *
 * Copyright (C) 1997-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#define QDDB_DATATREE_PROC_NEWINSTANCE 	0x01
#define QDDB_DATATREE_PROC_ADDNODE	0x02
#define QDDB_DATATREE_PROC_SETSEQ	0x03
#define QDDB_DATATREE_PROC_GETDATA	0x04
#define QDDB_DATATREE_PROC_SETMARK	0x05
#define QDDB_DATATREE_PROC_SETATTR	0x06

typedef struct qddb_dt {
    enum {
	DATATREE_STRING,		/* leaf node, string   */
	DATATREE_INT,			/* leaf node, int      */
	DATATREE_REAL,			/* leaf node, real     */
	DATATREE_DATE,			/* leaf node, date     */
        DATATREE_TIME,                  /* leaf node, time     */
	DATATREE_NOVAL,			/* leaf node, no value */
	DATATREE_END,			/* END marker (arrays) */
	DATATREE_CHILDREN		/* intermediate node   */
    }			datatree_type;
    Qddb_SchemaTreeNode	*datatree_schema;
    int			datatree_sequence_number;
    short		marked;		/* marked from incore */
    short		modified;	/* modified from Tcl script */
    union {
      char              *d_string;      /* datatree_string */
      char              *d_date;	/* datatree_date */
      char              *d_time;        /* datatree_time */
      int               d_int;		/* datatree_int */
      double            d_real;		/* datatree_real */
      struct qddb_dt    **d_children;	/* Array of DataTree pointers */
    } un;
} Qddb_DataTree;

#define datatree_string 	un.d_string
#define datatree_int    	un.d_int
#define datatree_real   	un.d_real
#define datatree_date		un.d_date
#define datatree_time           un.d_time
#define datatree_children 	un.d_children

void *Qddb_DataTreeProcess _ANSI_ARGS_((Qddb_Schema *, Qddb_DataTree **, CONST void *, int, int));


