
/* $RCSfile: Qddb_Utils.h,v $ $Revision: 2.1 $ $Date: 2003/03/23 17:16:14 $
 *
 * Copyright (C) 1997-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#if !defined(_QDDB_UTILS_H_)
#define _QDDB_UTILS_H_

#define QDDB_AUTOINC_FILENAME ".qddb_autoinc"


void 			Qddb_ReadEntry _ANSI_ARGS_((int, Qddb_Entry *, off_t, size_t, Qddb_Boolean));
int 			Qddb_ReadEntryByKeyList _ANSI_ARGS_((int, char *, Qddb_Entry *, \
							     Qddb_KeyList *, Qddb_Boolean));
int 			Qddb_ReadEntryByKeyList2 _ANSI_ARGS_((int, char *, Qddb_Entry *, \
							      Qddb_KeyList *, Qddb_Boolean));
void			Qddb_WriteEntry _ANSI_ARGS_((Qddb_Schema *, int, Qddb_Entry));
int			Qddb_EntryChanged _ANSI_ARGS_((char *, size_t *));
Qddb_Boolean		Qddb_EntryInvalid _ANSI_ARGS_((Qddb_Entry));
Qddb_Boolean            Qddb_EntryIsValid _ANSI_ARGS_((Qddb_Schema *, Qddb_KeyList *));
void			Qddb_InvalidateEntry _ANSI_ARGS_((Qddb_Schema *, off_t, size_t));
void			Qddb_InvalidateEntryByNumber _ANSI_ARGS_((Qddb_Schema *, size_t));
size_t			Qddb_GetEntryNumber _ANSI_ARGS_((Qddb_Entry));

char			*Qddb_FindRelation _ANSI_ARGS_((CONST char *));
int			Qddb_StrcmpNoupper _ANSI_ARGS_((char *, char *));
Qddb_Boolean		Qddb_IsNumericString _ANSI_ARGS_((char *));
void			Qddb_SkipSpaces _ANSI_ARGS_((char **));
void			Qddb_StripBackslashes _ANSI_ARGS_((char *));
char			*Qddb_InstanceToString _ANSI_ARGS_((size_t *, size_t));
int			Qddb_StringToInstance _ANSI_ARGS_((char *, size_t *));
char			*Qddb_IntegerToString _ANSI_ARGS_((int));
char			*Qddb_FastIntegerToString _ANSI_ARGS_((int));
char			*Qddb_DateStringToTime _ANSI_ARGS_((CONST char *));
char			*Qddb_DateTimeToString _ANSI_ARGS_((CONST char *, CONST char *));
void 			Qddb_DeleteEntryByNumber _ANSI_ARGS_((Qddb_Schema *, size_t));
void 			Qddb_DeleteEntryByKeyList _ANSI_ARGS_((Qddb_Schema *, Qddb_KeyList *));
Qddb_KeyList 		*Qddb_CatRelation _ANSI_ARGS_((Qddb_Schema *, off_t, size_t));
char			*Qddb_FieldString _ANSI_ARGS_((char *, size_t));

void			Qddb_SplitBufferIntoLines _ANSI_ARGS_((Qddb_Entry *, char *, size_t));
char			*Qddb_GetFile _ANSI_ARGS_((int));
void			Qddb_SetBuffer _ANSI_ARGS_((char *));
size_t			Qddb_ReadBuffer _ANSI_ARGS_((char *, size_t));
void			Qddb_InitBuffer _ANSI_ARGS_((void));
char			*Qddb_GetBuffer _ANSI_ARGS_((void));
char			*Qddb_GetBufferWithoutResize _ANSI_ARGS_((void));
size_t 			Qddb_GetBufferLength _ANSI_ARGS_((void));
void 			Qddb_SetBufferLength _ANSI_ARGS_((size_t));
void 			Qddb_SetBufferSize _ANSI_ARGS_((size_t));
void			Qddb_ConcatBuffer _ANSI_ARGS_((CONST char *));
void			Qddb_ConcatPrintableBuffer _ANSI_ARGS_((CONST char *));
void			Qddb_ConcatEscapeBuffer _ANSI_ARGS_((CONST char *, int));
char			*Qddb_PrintErrno _ANSI_ARGS_((int));
int 			Qddb_TranslateExternalID _ANSI_ARGS_((Qddb_Schema *, char *, size_t *, char **));

int			Qddb_CheckDate _ANSI_ARGS_((CONST char *));

int			Qddb_GetDate _ANSI_ARGS_((CONST char *, time_t, long, time_t *));
int			Qddb_GetTimeZone _ANSI_ARGS_((time_t));
int                     Qddb_GetZoneSeconds _ANSI_ARGS_((void));

char			*Qddb_FindKey _ANSI_ARGS_((char *, size_t *));
char			*Qddb_StripKey _ANSI_ARGS_((char *, size_t));

int			Qddb_GetInt _ANSI_ARGS_((CONST char *));
double			Qddb_GetNum _ANSI_ARGS_((CONST char *));

void 			Qddb_FillChars _ANSI_ARGS_((char *, int, int));

char                    *Qddb_IntToSpreadsheetIndex _ANSI_ARGS_((int));

char                    *Qddb_SizeToBase _ANSI_ARGS_((size_t, int));
size_t                  Qddb_BaseToSize _ANSI_ARGS_((CONST char *, int));
char                    *Qddb_OffsetToBase _ANSI_ARGS_((off_t, int));
off_t                   Qddb_BaseToOffset _ANSI_ARGS_((CONST char *, int));
Qddb_Entry              Qddb_ReadExcludeWords _ANSI_ARGS_((Qddb_Schema *, size_t *));

double                  Qddb_PrinterPoints _ANSI_ARGS_((CONST char *));

char                    *Qddb_NodeToAttribute _ANSI_ARGS_((Qddb_Schema *, Qddb_SchemaNode *));
void                    Qddb_AutoIncrement _ANSI_ARGS_((int, char *, size_t, char *, int, int));


#if defined(USE_TCL)
Qddb_Entry		Qddb_GetEntryFromCache _ANSI_ARGS_((char *));
#endif

int Qddb_FindAttributeNumber _ANSI_ARGS_((Qddb_Schema *, size_t *, int));
int Qddb_FindAttributeNumberFromString _ANSI_ARGS_((Qddb_Schema *, char *));


int			Qddb_yyerror _ANSI_ARGS_((char *));
#endif

