
/* $RCSfile: tclAppInit.c,v $ $Revision: 2.2 $ $Date: 2003/03/23 17:16:17 $
 *
 * Copyright (C) 1995-2003 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "tcl.h"
#include "Qddb.h"
#include "tclQddb.h"

#if defined(USE_TCLX) && USE_TCLX == 1
#include "tclExtend.h"
#endif

#if defined(USE_EXPECT) && USE_EXPECT == 1
int Exp_Init _ANSI_ARGS_((Tcl_Interp *));
#endif

#if defined(USE_ITCL) || defined(USE_ITCL2)
int Itcl_Init _ANSI_ARGS_((Tcl_Interp *));
#endif

#if defined(USE_TCL_TCP) && USE_TCL_TCP == 1
int TclTCP_Init _ANSI_ARGS_((Tcl_Interp *));
#endif

int Tcl_AppInit _ANSI_ARGS_((Tcl_Interp *));

int main _ANSI_ARGS_((int, char **));

int main(argc, argv)
    int argc;           /* Number of command-line arguments. */
    char **argv;        /* Values of command-line arguments. */
{
#if !defined(USE_TCLX) || USE_TCLX == 0
    Tcl_Main(argc, argv, Tcl_AppInit);
#else
    TclX_Main(argc, argv, Tcl_AppInit);
#endif
    return 0;           /* Needed only to prevent compiler warning. */
}


int Tcl_AppInit(interp)
    Tcl_Interp *interp;		/* Interpreter for application. */
{
    if (Tcl_Init(interp) == TCL_ERROR) {
	return TCL_ERROR;
    }
#if defined(USE_TCLX) || USE_TCLX == 1
    /* Using the standard TclX stuff causes a problem
     * with itcl.   Just include the various commands.
     */
    if (TclXCmd_Init (interp) == TCL_ERROR) {
        return TCL_ERROR;
    }
#endif

#if defined(USE_EXPECT) && USE_EXPECT == 1
    if (Exp_Init (interp) == TCL_ERROR) {
        return TCL_ERROR;
    }
#endif

#if defined(USE_TCL) && USE_TCL == 1
    if (Itcl_Init(interp) == TCL_ERROR)
	return TCL_ERROR;
#endif

    if (TclQddb_Init(interp) == TCL_ERROR)
	return TCL_ERROR;

    /*
     * Specify a user-specific startup file to invoke if the application
     * is run interactively.  Typically the startup file is "~/.apprc"
     * where "app" is the name of the application.  If this line is deleted
     * then no user-specific startup file will be run under any conditions.
     */
    Tcl_SetVar(interp, "tcl_rcFileName", "~/.qddb_tclshrc", TCL_GLOBAL_ONLY);
    Tcl_CreateExitHandler(TclQddb_DeleteSchemaProc, (ClientData)interp);
    return TCL_OK;
}
