# $RCSfile: fx_colors.tcl,v $ $Revision: 2.3 $ $Date: 2001/10/18 03:01:32 $
#
# Copyright (C) 1995-2001 Herrin Software Development, Inc.
# All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


proc Fx:ColorInit {} {
    global fx_config qddb_library tk_version

    if {![info exists fx_config(mandatory_field_bg)]} {
	set fx_config(mandatory_field_bg) e0e0e0
    }
    if {![info exists fx_config(\$palette\$)]} {
	set fx_config(\$palette\$) e9e9e9
	catch {Fx:SetPalette $fx_config(\$palette\$)}
    } else {
	catch {Fx:SetPalette $fx_config(\$palette\$)}
    }
}

proc Fx:ConfigureColors {} {
    global fx_config

    if {[info exists fx_config(\$palette\$)]} {
	set color [Fx:SelectColor . $fx_config(\$palette\$)]
    } else {
	set color [Fx:SelectColor .]
    }
    if {$color != ""} {
	set fx_config(\$palette\$) $color
	Fx:SetPalette $color
    }
}

proc Fx:SelectColor {w {default "e9e9e9"}} {
    if {[catch {winfo rgb . $default} error]} {
	set default "\#e9e9e9"
    }
    set retval [tk_chooseColor -initialcolor "$default" -parent $w -title "Color Selection"]
    if {$retval == ""} {
	set retval $default
    }
    return [string range $retval 1 end]
}

proc Fx:SetPalette args {
    eval tk_setPalette' "\#[lindex $args 0]"
    return ""
}

if {[info exists fx_debug] && $fx_debug == 1} {
    puts "auto-loaded fx_colors.tcl"
}
