# $RCSfile: fx_import.tcl,v $ $Revision: 2.1 $ $Date: 2001/08/04 16:40:42 $
#
# Copyright (C) 1995-2000 Herrin Software Development, Inc.
# All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


itcl::class Fx_Import {
    constructor {args} {
	global ::qddb_library ::fx_tmpconfig ::fx_monochrome

	eval configure $args
	set nthis [namespace tail $this]
	if {[winfo exists .$nthis]} {
	    set nodelete 1
	    itcl::delete object $this
	}
	if {$fx_monochrome} {
	    set mono 1
	}
	set oldfocus [focus]
	toplevel .$nthis
	wm title .$nthis $title
	global ::${configvar}
	if {[info exists ${configvar}(geom,$nthis)]} {
	    wm geometry .$nthis [set ${configvar}(geom,$nthis)]
	}
	set c .$nthis
	set x 0
	foreach i $attrs {
	    set attr_array($i) $x
	    incr x
	}
	set max_attrs $x
	frame $c.bot -relief raised -bd 3
	pack $c.bot -side bottom -fill x
	button $c.bot.ok -text Ok -padx 5m -pady 2m \
	    -command [list $this SaveConfig]
	pack $c.bot.ok -side left -padx 10m -pady 4m 
	button $c.bot.cancel -text Cancel -padx 5m -pady 2m \
	    -command [list $this Quit]
	pack $c.bot.cancel -side left -padx 10m -pady 4m
	if {$rw} {
	    button $c.bot.read -text "Read from file" -padx 5m -pady 2m \
		    -command [list $this ReadFile]
	    button $c.bot.write -text "Write to file" -padx 5m -pady 2m \
		    -command [list $this WriteFile]
	    pack $c.bot.write -side right -padx 10m -pady 4m
	    pack $c.bot.read -side right -padx 10m -pady 4m
	}

	frame $c.top -relief raised -bd 3
	pack $c.top -side top -expand on -fill both

	if {![info exists ${configvar}($idx,print)]} {
	    set ${configvar}($idx,print) [lrange $attrs 0 4]
	}
	frame $c.top.m
	pack $c.top.m -side left -expand on -fill both

	label $c.top.m.l -text "Import Columns"
	set listbox(${nthis}_import_print) $c.top.m.print
	Fx_MultiColumnListBox ${nthis}_import_print -w $c.top.m.print -side top -numcols 4 \
	    -width 20 -headings {Verbosename Attribute "Link field" "Ignore column"} \
	    -align {left left left left} -single_select off -separators {" " " " " " " "} \
	    -initselection off \
	    -height 10 -onselect [list $this PrintSelect]
	pack forget $c.top.m.print
	set info {}
	set x 0
	foreach i [set ${configvar}($idx,print)] {
	    set verb [qddb_schema option verbosename $schema $i]
	    if {[llength $verb] == 0} {
		set verb [split $i .] 
		set verb [lindex $verb [expr [llength $verb] - 1]]
	    }
	    lappend info [list $verb $i No No]
	    incr x
	}
	${nthis}_import_print AppendRows $info
	${nthis}_import_print BuildFormats 1
	${nthis}_import_print Format
	${nthis}_import_print Display
	bind $listbox(${nthis}_import_print).l2 <Button-3> [list $this MoveTo %y]

	frame $c.top.m.r
	pack $c.top.m.r -side right -fill y -anchor s
	set bf $c.top.m.r
	set up @${qddb_library}/fx/pixmaps/up.xbm
	set down @${qddb_library}/fx/pixmaps/down.xbm
	set right @${qddb_library}/fx/pixmaps/right.xbm
	set left @${qddb_library}/fx/pixmaps/left.xbm
	label $bf.top
	pack $bf.top -fill x
	button $bf.up -bitmap $up -command [list $this MoveUp]
	if {$mono == 0} {
	    $bf.up configure -fg blue
	}
	pack $bf.up -expand on -fill y -ipady 5m
	lappend printconf(enable) $bf.up
	lappend dontprintconf(disable) $bf.up
	button $bf.down -bitmap $down -command [list $this MoveDown]
	if {$mono == 0} {
	    $bf.down configure -fg blue
	}
	pack $bf.down -expand on -fill y -ipady 5m
	lappend printconf(enable) $bf.down
	lappend dontprintconf(disable) $bf.down
	button $bf.right -bitmap $right -command [list $this MoveRight]
	if {$mono == 0} {
	    $bf.right configure -fg blue
	}
	pack $bf.right -expand on -fill y -ipady 5m
	lappend printconf(enable) $bf.right
	lappend dontprintconf(disable) $bf.right
	button $bf.left -bitmap $left -command [list $this MoveLeft]
	if {$mono == 0} {
	    $bf.left configure -fg blue
	}
	pack $bf.left -expand on -fill y -ipady 5m
	lappend printconf(disable) $bf.left
	lappend dontprintconf(enable) $bf.left
	pack $c.top.m.l -side top -fill x -anchor n
	pack $c.top.m.print -side left -expand on -fill both

	frame $c.top.r
	pack $c.top.r -side left -expand on -fill both
	label $c.top.r.l -text "Available Attributes"
	pack $c.top.r.l -side top -fill x -anchor n
	set listbox(${nthis}_import_dontprint) $c.top.r.dontprint
	Fx_MultiColumnListBox ${nthis}_import_dontprint -w $c.top.r.dontprint -side top -numcols 2 \
	    -width 15 -headings {Verbosename Attribute} \
	    -align {left left} -single_select off -separators {" " " "} \
	    -initselection off \
	    -height 10 -onselect [list $this DontPrintSelect]
	if {![info exists ${configvar}($idx,dontprint)]} {
	    ::set ${configvar}($idx,dontprint) {}
	    if {[info exists ${configvar}($idx,print)]} {
		foreach i $attrs {
		    set use 1
		    foreach j [::set ${configvar}($idx,print)] {
			if {[string compare $i $j] == 0} {
			    set use 0
			    break
			}
		    }
		    if {$use != 0} {
			lappend ${configvar}($idx,dontprint) $i
		    }
		}
	    } else {
		::set ${configvar}($idx,dontprint) $attrs
		::set ${configvar}($idx,print) {}
	    }
	} else {
	    if {[llength $attrs] != [expr [llength [set ${configvar}($idx,dontprint)]] + \
		    [llength [set ${configvar}($idx,print)]]]} {
		foreach i $attrs {
		    if {[lsearch -exact [set ${configvar}($idx,dontprint)] $i] == -1 && \
			    [lsearch -exact [set ${configvar}($idx,print)] $i] == -1} {
			lappend ${configvar}($idx,dontprint) $i
		    }
		}
	    }
	    ::set ${configvar}($idx,dontprint) \
		    [lsort -command [list $this SortAttrs] [set ${configvar}($idx,dontprint)]]
	}
	set info {}
	foreach i [set ${configvar}($idx,dontprint)] {
	    set verb [qddb_schema option verbosename $schema $i]
	    if {[llength $verb] == 0} {
		set verb [split $i .] 
		set verb [lindex $verb [expr [llength $verb] - 1]]
	    }
	    lappend info [list $verb $i]
	}
	${nthis}_import_dontprint AppendRows $info
	${nthis}_import_dontprint BuildFormats 1
	${nthis}_import_dontprint Format
	${nthis}_import_dontprint Display

	frame $c.mid -relief raised -bd 3
	pack $c.mid -side top -fill x
	set d $c.mid

	# Field settings
	frame $d.f1 -relief sunken -bd 2
	pack $d.f1 -side left -fill x
# NOT YET
	checkbutton $d.f1.l -text "Treat as link field" -anchor e -relief raised -bd 2 \
		-variable fx_tmpconfig($idx,linkfield) -state disabled
	pack $d.f1.l -side left -anchor e
	checkbutton $d.f1.l1 -text "Ignore column" -anchor e -relief raised -bd 2 \
		-variable fx_tmpconfig($idx,ignore) -state disabled
	pack $d.f1.l1 -side left -anchor e

	NoSelect
	bind .$nthis <Configure> [list $this ConfigureWindow]
	if {[info exists ${configvar}(geom,$nthis)]} {
	    wm geometry .$nthis [set ${configvar}(geom,$nthis)]
	}
    }    
    destructor {
	global ::fx_tmpconfig

	if {$nodelete == 0} {
	    catch "itcl::delete object ${nthis}_import_print"
	    catch "itcl::delete object ${nthis}_import_dontprint"
	    if {[winfo exists .${nthis}_readfile]} {
		.${nthis}_readfile.but.cancel invoke
	    }
	    if {[winfo exists .${nthis}_writefile]} {
		.${nthis}_writefile.but.cancel invoke
	    }
	    catch {destroy .$nthis}
	    trace vdelete fx_tmpconfig($idx,ignore) w [list $this PrintTrace]
	    trace vdelete fx_tmpconfig($idx,linkfield) w [list $this PrintTrace]
	}
	focus $oldfocus
    }
    method ConfigureWindow {} {
	global ::${configvar}

	update idletasks
	::set ${configvar}(geom,$nthis) [wm geometry .$nthis]
    }
    method SortAttrs {a b} {
	if {![info exists attr_array($a)]} {
	    if {![info exists attr_array($b)]} {
		return 0
	    } else {
		return 1
	    }
	} elseif {![info exists attr_array($b)]} {
	    return -1
	}
	return [expr $attr_array($a) - $attr_array($b)]
    }
    method NoSelect {} {
	foreach i $dontprintconf(enable) {
	    $i configure -state disabled
	}
	foreach i $dontprintconf(disable) {
	    $i configure -state disabled
	}
    }
    method DontPrintSelect {i} {
	global ::fx_tmpconfig

	set current_listbox ${nthis}_import_dontprint
	foreach i $dontprintconf(enable) {
	    $i configure -state normal
	}
	foreach i $dontprintconf(disable) {
	    $i configure -state disabled
	}
	trace vdelete fx_tmpconfig($idx,ignore) w [list $this PrintTrace]
	trace vdelete fx_tmpconfig($idx,linkfield) w [list $this PrintTrace]
    }
    method PrintSelect {i} {
	global ::fx_tmpconfig
	
	set current_listbox ${nthis}_import_print
	foreach j $printconf(enable) {
	    $j configure -state normal
	}
	foreach j $printconf(disable) {
	    $j configure -state disabled
	}
	set lasti $i
	set leni [llength $i]
	if {$leni > 1} {
	    set row [$current_listbox GetRow [lindex $i 0]]
	} else {
	    set row [$current_listbox GetRow $i]
	}
	trace vdelete fx_tmpconfig($idx,ignore) w [list $this PrintTrace]
	trace vdelete fx_tmpconfig($idx,linkfield) w [list $this PrintTrace]
	set tmpjust [lindex $row 2]
	if {[string compare $tmpjust Yes] == 0} {
	    ::set fx_tmpconfig($idx,linkfield) 1
	} else {
	    ::set fx_tmpconfig($idx,linkfield) 0
	}
	set tmpjust [lindex $row 3]
	if {[string compare $tmpjust Yes] == 0} {
	    ::set fx_tmpconfig($idx,ignore) 1
	} else {
	    ::set fx_tmpconfig($idx,ignore) 0
	}
	trace variable fx_tmpconfig($idx,ignore) w [list $this PrintTrace]
	trace variable fx_tmpconfig($idx,linkfield) w [list $this PrintTrace]
    }
    method PrintTrace {n1 n2 op} {
	global ::fx_tmpconfig

	set oldactive [$listbox(${nthis}_import_print).l2 index active]
	set newn [lindex [split $n2 ,] 1]
	foreach j $lasti {
	    set r [${nthis}_import_print GetRow $j]
	    switch $newn {
		linkfield {
		    if {$fx_tmpconfig($idx,linkfield) == 0} {
			set r [lreplace $r 2 2 No]
		    } else {
			set r [lreplace $r 2 2 Yes]
		    }
		}
		ignore {
		    if {$fx_tmpconfig($idx,ignore) == 0} {
			set r [lreplace $r 3 3 No]
		    } else {
			set r [lreplace $r 3 3 Yes]
		    }
		}
	    }
	    ${nthis}_import_print ReplaceRow $j $r
	}
	${nthis}_import_print CalculateWidths
	${nthis}_import_print BuildFormats 1
	${nthis}_import_print Format
	${nthis}_import_print Display
	foreach i $lasti {
	    $listbox(${nthis}_import_print).l2 select set $i $i
	}
	$listbox(${nthis}_import_print).l2 activate $oldactive
    }
    method MoveTo {y} {
        $current_listbox MoveTo [$listbox($current_listbox).l2 nearest $y]
	set lasti [$listbox($current_listbox).l2 curselection]
    }
    method MoveUp {} {
	$current_listbox MoveUp
	set lasti [$listbox($current_listbox).l2 curselection]
    }
    method MoveDown {} {
	$current_listbox MoveDown
	set lasti [$listbox($current_listbox).l2 curselection]
    }
    method MoveRight {} {
	if {[string compare $current_listbox ${nthis}_import_print] != 0} {
	    return
	}
	set l [$listbox(${nthis}_import_print).l2 curselection]
	set len [llength $l]
	if {$len == 0} {
	    return
	}
	if {$len > 1} {
	    set r [$current_listbox DeleteRows $l]
	    foreach i $r {
		${nthis}_import_dontprint AppendRow [lrange [concat $i] 0 1]
	    }
	    ${nthis}_import_dontprint FastSortContents $attrs
	    ${nthis}_import_dontprint CalculateWidths
	    ${nthis}_import_dontprint BuildFormats 1
	    ${nthis}_import_dontprint Format
	    ${nthis}_import_dontprint Display
	} else {
	    set r [$current_listbox DeleteRow $l]
	    eval ${nthis}_import_dontprint AppendRow [lrange [concat $r] 0 1]
	    ${nthis}_import_dontprint FastSortContents $attrs
	    ${nthis}_import_dontprint CalculateWidths
	    ${nthis}_import_dontprint BuildFormats 1
	    ${nthis}_import_dontprint Format
	    ${nthis}_import_dontprint Display
	}
	NoSelect
    }
    method MoveLeft {} {
	if {[string compare $current_listbox ${nthis}_import_dontprint] != 0} {
	    return
	}
	set l [$listbox(${nthis}_import_dontprint).l2 curselection]
	set len [llength $l]
	if {$len == 0} {
	    return
	}
	if {$len > 1} {
	    set r [$current_listbox DeleteRows $l]
	    foreach i $r {
		set k $i
		lappend k No No
		${nthis}_import_print AppendRow $k
	    }
	} else {
	    set r [$current_listbox DeleteRow $l]
	    set k [lindex $r 0]
	    lappend k No No
	    ${nthis}_import_print AppendRow $k
	}
	${nthis}_import_print CalculateWidths
	${nthis}_import_print BuildFormats
	${nthis}_import_print Format
	${nthis}_import_print Display
	NoSelect
    }
    method ReadFile {} {
	global ::fx_tmpconfig ::fx_blt

	set f [Fx:FileSelect .${nthis}.readfile r $restrict]
	if {[llength $f] == 0} {return}
	if {[catch [list open $f r] fd] != 0} {
	    fx_dialog .dialog "Error reading file" \
		"$fd  Fix the problem and try again." error 0 OK
	    return
	}
	set r [read $fd]
	close $fd
	if {[llength $r] != 4 || [string compare [qddb_schema leaves $schema] [lindex $r 0]] != 0 \
		|| [string compare $nthis [lindex $r 1]] != 0} {
	    fx_dialog .dialog "Error reading file" \
		"This file does not appear to be a valid configuration file." error 0 OK
	    return
	}
	if {$fx_blt} {
	    ::blt::busy hold .$nthis
	}
	${nthis}_import_print ClearRows
	${nthis}_import_print ClearContents
	${nthis}_import_print AppendRows [lindex $r 2]
	${nthis}_import_print BuildFormats 1
	${nthis}_import_print Format
	${nthis}_import_print Display
	${nthis}_import_dontprint ClearRows
	${nthis}_import_dontprint ClearContents
	${nthis}_import_dontprint AppendRows [lindex $r 3]
	${nthis}_import_dontprint BuildFormats 1
	${nthis}_import_dontprint Format
	${nthis}_import_dontprint Display
	if {$fx_blt} {
	    catch {blt::busy forget .$nthis}
	}
    }
    method WriteFile {} {
	set f [Fx:FileSelect .${nthis}.writefile w $restrict]
	if {[llength $f] == 0} {return}
	set r2 [${nthis}_import_print GetContents]
	set r3 [${nthis}_import_dontprint GetContents]
	if {[catch [list open $f w] fd] != 0} {
	    fx_dialog .dialog "Error writing file" \
		"$fd  Fix the problem and try again." error 0 OK
	    return
	}
	puts -nonewline $fd [list [qddb_schema leaves $schema] $nthis $r2 $r3]
	close $fd
    }
    method SaveConfig {} {
	global ::${configvar} ::fx_dialog ::fx_tmpconfig

	# print
	# widths
	# alignment
	# separators
	set r [${nthis}_import_print GetContents]
	::set ${configvar}($idx,print) {}
	foreach i $r {
	    lappend ${configvar}($idx,print) [lindex $i 1]
	}
	set r [${nthis}_import_dontprint GetContents]
	::set ${configvar}($idx,dontprint) {}
	foreach i $r {
	    lappend ${configvar}($idx,dontprint) [lindex $i 1]
	}
	::set ${configvar}($idx,attrs) $attrs
	::set fx_dialog($nthis) ok
	itcl::delete object $this
    }
    method Quit {} {
	global ::fx_dialog

	::set fx_dialog($nthis) cancel
	itcl::delete object $this
    }

    public variable schema
    public variable title "Configuration"
    public variable configvar fx_config
    public variable idx ""
    public variable checkattrs 0
    public variable attrs
    public variable attr_array
    public variable max_attrs
    public variable restrict ""
    public variable rw 1

    protected variable nodelete 0
    protected variable nthis
    protected variable sortbyconf
    protected variable printconf
    protected variable dontprintconf
    protected variable mono 0
    protected variable current_listbox
    protected variable listbox
    protected variable lasti {}
    protected variable oldfocus
}
