# $RCSfile: fx_resources.tcl,v $ $Revision: 2.2 $ $Date: 2001/10/18 03:01:33 $
#
# Copyright (C) 1995-2000 Herrin Software Development, Inc.
# All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


proc Fx:InitResources {} {
    global fx_font fx_classes

    if {![info exists fx_font]} {
	foreach i $fx_classes {
	    option add "*$i.font" $fx_font
	}
	option add *Listbox.Font -*-courier-bold-r-*-*-*-140-*-*-*-*-*-*
    } else {
	foreach i $fx_classes {
	    option add "*$i.font" $fx_font
	}
    }
}

set fx_resources {
    Button.activeForeground
    Button.activeBackground
    Button.background
    Button.foreground
    Button.disabledForeground
    Button.font
    Canvas.background
    Canvas.foreground
    Canvas.selectBackground
    Canvas.selectForeground
    Checkbutton.activeBackground
    Checkbutton.activeForeground
    Checkbutton.background
    Checkbutton.foreground
    Checkbutton.disabledForeground
    Checkbutton.font
    Entry.background
    Entry.foreground
    Entry.font
    Entry.selectBackground
    Entry.selectForeground
    Frame.background
    Label.background
    Label.foreground
    Label.font
    Listbox.background
    Listbox.foreground
    Listbox.font
    Listbox.selectBackground
    Listbox.selectForeground
    Menu.activeBackground
    Menu.activeForeground
    Menu.background
    Menu.foreground
    Menu.font
    Menu.disabledForeground
    Menubutton.activeBackground
    Menubutton.activeForeground
    Menubutton.background
    Menubutton.foreground
    Menubutton.disabledForeground
    Menubutton.font
    Message.background
    Message.foreground
    Message.font
    NoteBook.background
    NoteBook.foreground
    NoteBook.font
    Radiobutton.activeBackground
    Radiobutton.activeForeground
    Radiobutton.background
    Radiobutton.foreground
    Radiobutton.disabledForeground
    Radiobutton.font
    Scale.activeForeground
    Scale.background
    Scale.foreground
    Scale.font
    Scrollbar.activeForeground
    Scrollbar.background
    Scrollbar.foreground
    Scrollbar.Width
    Text.background
    Text.foreground
    Text.font
    Text.selectBackground
    Text.selectForeground
}

set fx_classes {
    Button
    Canvas
    Checkbutton
    Entry
    Frame
    Label
    Listbox
    Menu
    Menubutton
    Message
    NoteBook
    Radiobutton
    Scale
    Scrollbar
    Text
}
if {[string compare [info commands tktable] tktable] == 0} {
    lappend fx_classes TkTable
    lappend fx_resources TkTable.background TkTable.foreground TkTable.font
}
set fx_classes [lsort $fx_classes]
if {[info exists fx_debug] && $fx_debug == 1} {
    puts "auto-loaded fx_resources.tcl"
}
