
/* $RCSfile: Init.c,v $ $Revision: 2.0.0.1 $ $Date: 2000/11/09 15:06:03 $
 *
 * Copyright (C) 1993-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "Qddb.h"

void Qddb_Init _ANSI_ARGS_((void))
{
    uid_t		me;
    char                *datefmt;
#if defined(HAVE_SETRLIMIT) && defined(HAVE_GETRLIMIT)
    struct rlimit	lim;
    long                oldmax;
#endif

    me = getuid();
#if defined(HAVE_SETRLIMIT) && defined(HAVE_GETRLIMIT)
#if defined(RLIMIT_DATA)
    getrlimit(RLIMIT_DATA, &lim);
    oldmax = lim.rlim_max;
#if defined(RLIM_INFINITY)
    if (me == 0)
       lim.rlim_cur = lim.rlim_max = RLIM_INFINITY;
    else
#endif
       lim.rlim_cur = lim.rlim_max;
    if (setrlimit(RLIMIT_DATA, &lim) == -1) {
        lim.rlim_cur = lim.rlim_max = oldmax;
        setrlimit(RLIMIT_DATA, &lim);
    }
#endif
#if defined(RLIMIT_STACK)
    getrlimit(RLIMIT_STACK, &lim);
    oldmax = lim.rlim_max;
#if defined(RLIM_INFINITY)
    if (me == 0)
       lim.rlim_cur = lim.rlim_max = RLIM_INFINITY;
    else
#endif
	lim.rlim_cur = lim.rlim_max;
    if (setrlimit(RLIMIT_STACK, &lim) == -1) {
        lim.rlim_cur = lim.rlim_max = oldmax;
        setrlimit(RLIMIT_STACK, &lim);
    }
#endif
#if defined(RLIMIT_RSS)
    getrlimit(RLIMIT_RSS, &lim);
    oldmax = lim.rlim_max;
#if defined(RLIM_INFINITY)
    if (me == 0)
       lim.rlim_cur = lim.rlim_max = RLIM_INFINITY;
    else
#endif
	lim.rlim_cur = lim.rlim_max;
    if (setrlimit(RLIMIT_RSS, &lim) == -1) {
        lim.rlim_cur = lim.rlim_max = oldmax;
        setrlimit(RLIMIT_RSS, &lim);
    }
#endif
#if defined(RLIMIT_FSIZE)
    getrlimit(RLIMIT_FSIZE, &lim);
    oldmax = lim.rlim_max;
#if defined(RLIM_INFINITY)
    if (me == 0)
       lim.rlim_cur = lim.rlim_max = RLIM_INFINITY;
    else
#endif
	lim.rlim_cur = lim.rlim_max;
    if (setrlimit(RLIMIT_FSIZE, &lim) == -1) {
        lim.rlim_cur = lim.rlim_max = oldmax;
        setrlimit(RLIMIT_FSIZE, &lim);
    }
#endif
#if defined(RLIMIT_CPU)
    getrlimit(RLIMIT_CPU, &lim);
    oldmax = lim.rlim_max;
#if defined(RLIM_INFINITY)
    if (me == 0)
        lim.rlim_cur = lim.rlim_max = RLIM_INFINITY;
    else
#endif
	lim.rlim_cur = lim.rlim_max;
    if (setrlimit(RLIMIT_CPU, &lim) == -1) {
        lim.rlim_cur = lim.rlim_max = oldmax;
        setrlimit(RLIMIT_CPU, &lim);
    }
#endif
#if defined(RLIMIT_NOFILE)
    getrlimit(RLIMIT_NOFILE, &lim);
    oldmax = lim.rlim_max;
#if defined(RLIM_INFINITY)
    if (me == 0 && lim.rlim_cur != lim.rlim_max) {
        lim.rlim_cur = lim.rlim_max = RLIM_INFINITY;
	if (setrlimit(RLIMIT_NOFILE, &lim) == -1) {
  	    lim.rlim_cur = lim.rlim_max = oldmax;
	    setrlimit(RLIMIT_NOFILE, &lim);
	}
    } else
#endif
    if (lim.rlim_cur != lim.rlim_max) {
        lim.rlim_cur = lim.rlim_max;
	setrlimit(RLIMIT_NOFILE, &lim);
    }
#endif
#endif
    if (strcmp(qddb_default_date_format, "%m/%d/%y") == 0) {
	qddb_datestyle = QDDB_DATE_STYLE_US;
    } else {
	qddb_datestyle = QDDB_DATE_STYLE_EUROPEAN;
    }
    datefmt = getenv("QDDB_DATESTYLE");
    if (datefmt != NULL) {
	if (strcasecmp(datefmt, "us") == 0) {
	    qddb_datestyle = QDDB_DATE_STYLE_US;
	    qddb_default_date_format = "%m/%d/%y";
	} else if (strcasecmp(datefmt, "european") == 0) {
	    qddb_datestyle = QDDB_DATE_STYLE_EUROPEAN;
	    qddb_default_date_format = "%d/%m/%y";
	}
    }
}
