
/* $RCSfile: Postscript.c,v $ $Revision: 2.1 $ $Date: 2003/03/23 17:16:54 $
 *
 * Copyright (C) 1993-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <Qddb.h>

static char *defs[] = {
    "/L { moveto show } bind def",
    "/PS { /level0 save def } bind def",
    "/PE { level0 restore showpage } bind def",
    "/RE {",
    "\tfindfont",
    "\tdup maxlength dict begin",
    "\t{",
    "\t\t1 index /FID ne { def } { pop pop } ifelse",
    "\t} forall",
    "\t/Encoding exch def",
    "\tdup /FontName exch def",
    "\tcurrentdict end definefont pop",
    "} bind def"
};

static char *latin1[256] = {
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    "space",
    "exclam",
    "quotedbl",
    "numbersign",
    "dollar",
    "percent",
    "ampersand",
    "quoteright",
    "parenleft",
    "parenright",
    "asterisk",
    "plus",
    "comma",
    "hyphen",  /* this should be `minus', but not all PS printers have it */
    "period",
    "slash",
    "zero",
    "one",
    "two",
    "three",
    "four",
    "five",
    "six",
    "seven",
    "eight",
    "nine",
    "colon",
    "semicolon",
    "less",
    "equal",
    "greater",
    "question",
    "at",
    "A",
    "B",
    "C",
    "D",
    "E",
    "F",
    "G",
    "H",
    "I",
    "J",
    "K",
    "L",
    "M",
    "N",
    "O",
    "P",
    "Q",
    "R",
    "S",
    "T",
    "U",
    "V",
    "W",
    "X",
    "Y",
    "Z",
    "bracketleft",
    "backslash",
    "bracketright",
    "asciicircum",
    "underscore",
    "quoteleft",
    "a",
    "b",
    "c",
    "d",
    "e",
    "f",
    "g",
    "h",
    "i",
    "j",
    "k",
    "l",
    "m",
    "n",
    "o",
    "p",
    "q",
    "r",
    "s",
    "t",
    "u",
    "v",
    "w",
    "x",
    "y",
    "z",
    "braceleft",
    "bar",
    "braceright",
    "asciitilde",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    ".notdef",
    "dotlessi",
    "grave",
    "acute",
    "circumflex",
    "tilde",
    "macron",
    "breve",
    "dotaccent",
    "dieresis",
    ".notdef",
    "ring",
    "cedilla",
    ".notdef",
    "hungarumlaut",
    "ogonek",
    "caron",
    ".notdef",
    "exclamdown",
    "cent",
    "sterling",
    "currency",
    "yen",
    "brokenbar",
    "section",
    "dieresis",
    "copyright",
    "ordfeminine",
    "guilsinglleft",
    "logicalnot",
    "hyphen",
    "registered",
    "macron",
    "degree",
    "plusminus",
    "twosuperior",
    "threesuperior",
    "acute",
    "mu",
    "paragraph",
    "periodcentered",
    "cedilla",
    "onesuperior",
    "ordmasculine",
    "guilsinglright",
    "onequarter",
    "onehalf",
    "threequarters",
    "questiondown",
    "Agrave",
    "Aacute",
    "Acircumflex",
    "Atilde",
    "Adieresis",
    "Aring",
    "AE",
    "Ccedilla",
    "Egrave",
    "Eacute",
    "Ecircumflex",
    "Edieresis",
    "Igrave",
    "Iacute",
    "Icircumflex",
    "Idieresis",
    "Eth",
    "Ntilde",
    "Ograve",
    "Oacute",
    "Ocircumflex",
    "Otilde",
    "Odieresis",
    "multiply",
    "Oslash",
    "Ugrave",
    "Uacute",
    "Ucircumflex",
    "Udieresis",
    "Yacute",
    "Thorn",
    "germandbls",
    "agrave",
    "aacute",
    "acircumflex",
    "atilde",
    "adieresis",
    "aring",
    "ae",
    "ccedilla",
    "egrave",
    "eacute",
    "ecircumflex",
    "edieresis",
    "igrave",
    "iacute",
    "icircumflex",
    "idieresis",
    "eth",
    "ntilde",
    "ograve",
    "oacute",
    "ocircumflex",
    "otilde",
    "odieresis",
    "divide",
    "oslash",
    "ugrave",
    "uacute",
    "ucircumflex",
    "udieresis",
    "yacute",
    "thorn",
    "ydieresis",
};

typedef struct output_char {
    struct output_char     *next;
    char                   c;
    char                   is_bold;
    int                    pos;
} output_char;

static output_char *free_output_char_list = NULL;

static int     tab_width;
static int     lines_per_page;
static int     pageno;
static int     orient;

static double  page_length;
static double  baseline_offset;
static double  vertical_spacing;
static double  left_margin;
static double  char_width;

static char    *font;
static char    *bold_font;
static char    tmpbuf[BUFSIZ];

enum { NONE, ROMAN, BOLD } current_font;

static void PostscriptContents _ANSI_ARGS_((CONST char *));
static void PostscriptPrologue _ANSI_ARGS_((void));
static void PostscriptEpilogue _ANSI_ARGS_((void));
static output_char *PostscriptAllocateChar _ANSI_ARGS_((void));
static void PostscriptFreeChar _ANSI_ARGS_((output_char *));
static void PostscriptAddCharToLine _ANSI_ARGS_((int, int, output_char **));
static void PostscriptChar _ANSI_ARGS_((int));
static void PostscriptNumber _ANSI_ARGS_((double));
static void PostscriptPrintALine _ANSI_ARGS_((output_char *, int));
static void PostscriptStartPage _ANSI_ARGS_((void));
static void PostscriptEndPage _ANSI_ARGS_((void));


char *Qddb_TextToPostscript(text, options)
    CONST char              *text;
    Qddb_PostscriptOptions  *options;
{
    Qddb_InitBuffer();

    pageno = 0;
    char_width = options->char_width_pts;
    tab_width = options->tab_width_chars;
    lines_per_page = options->lines_per_page;
    page_length = options->page_length_pts;
    vertical_spacing = options->vertical_spacing_pts;
    baseline_offset = options->baseline_offset_pts + vertical_spacing;
    left_margin = options->left_margin_pts + char_width;
    font = options->font;
    bold_font = options->bold_font;
    orient = options->orient;

    PostscriptPrologue();
    PostscriptContents(text);
    PostscriptEpilogue();
    return Qddb_GetBufferWithoutResize();
}

static output_char *PostscriptAllocateChar()
{
    output_char        *tem;

    if (free_output_char_list) {
	tem = free_output_char_list;
	free_output_char_list = free_output_char_list->next;
    } else {
	tem = (output_char *)Malloc(sizeof(output_char));
    }
    return tem;
}

static void PostscriptFreeChar(p)
    output_char        *p;
{
    p->next = free_output_char_list;
    free_output_char_list = p;
}

static void PostscriptChar(c)
    int                c;
{
    if (!isascii(c) || iscntrl(c)) {
	sprintf(tmpbuf, "\\%03o", c & 0377);
	Qddb_ConcatBuffer(tmpbuf);
    } else if (c == '(' || c == ')' || c == '\\') {
	tmpbuf[0] = '\\';
	tmpbuf[1] = (char)c;
	tmpbuf[2] = '\0';
	Qddb_ConcatBuffer(tmpbuf);
    } else {
	tmpbuf[0] = (char)c;
	tmpbuf[1] = '\0';
	Qddb_ConcatBuffer(tmpbuf);
    }
}

static void PostscriptNumber(f)
    double            f;
{
    static char buf[100];
    char *p;

    sprintf(buf, "%f", f);
    for (p = buf + strlen(buf) - 1; *p != '.';  --p)
	if (*p != '0') {
	    p++;
	    break;
	}
    *p = '\0';
    Qddb_ConcatBuffer(buf);
}

/* output_line is ordered greatest position first */
static void PostscriptPrintALine(output_line, vpos)
    output_char     *output_line;
    int             vpos;
{
    output_char     *rev = output_line;

    output_line = 0;
    while (rev != 0) {
	output_char *tem = rev;
	rev = rev->next;
	tem->next = output_line;
	output_line = tem;
    }
    while (output_line != NULL) {
	output_char *tem;
	output_char **p = &output_line;
	int start_pos = output_line->pos;
	int is_bold = output_line->is_bold;
	int pos;

	if (is_bold) {
	    if (current_font != BOLD) {
		Qddb_ConcatBuffer("B");
		current_font = BOLD;
	    }
	} else {
	    if (current_font != ROMAN) {
		Qddb_ConcatBuffer("R");
		current_font = ROMAN;
	    }
	}
	Qddb_ConcatBuffer("(");
	PostscriptChar(output_line->c);
	pos = output_line->pos + 1;
	tem = output_line;
	output_line = output_line->next;
	PostscriptFreeChar(tem);
	for (;;) {
	    while (*p != NULL
		   && ((*p)->pos < pos || (*p)->is_bold != is_bold))
		p = &(*p)->next;
	    if (*p == NULL)
		break;
	    while (pos < (*p)->pos) {
		PostscriptChar(' ');
		pos++;
	    }
	    PostscriptChar((*p)->c);
	    pos++;
	    tem = *p;
	    *p = tem->next;
	    PostscriptFreeChar(tem);
	}
	Qddb_ConcatBuffer(")");
	PostscriptNumber(left_margin + start_pos*char_width);
	Qddb_ConcatBuffer(" ");
	PostscriptNumber(page_length - baseline_offset - vpos*vertical_spacing);
	Qddb_ConcatBuffer(" L\n");
    }
}

static void PostscriptStartPage()
{
    sprintf(tmpbuf, "%%%%Page: ? %d\n%%BeginPageSetup\nPS\n", ++pageno);
    Qddb_ConcatBuffer(tmpbuf);
    if (orient == QDDB_POSTSCRIPT_ORIENT_LANDSCAPE) {
	sprintf(tmpbuf, "%.0f 0 translate 90 rotate\n", page_length);
	Qddb_ConcatBuffer(tmpbuf);
    }
    Qddb_ConcatBuffer("%%EndPageSetup\n");
    current_font = NONE;
}

static void PostscriptEndPage()
{
    Qddb_ConcatBuffer("PE\n");
}

  
static void PostscriptPrologue()
{
    int col, i;
    
    Qddb_ConcatBuffer("%!PS-Adobe-3.0\n");
    Qddb_ConcatBuffer("%%DocumentNeededResources: font ");
    Qddb_ConcatBuffer(font);
    Qddb_ConcatBuffer("\n");
    Qddb_ConcatBuffer("%%+ font ");
    Qddb_ConcatBuffer(bold_font);
    Qddb_ConcatBuffer("\n");
    Qddb_ConcatBuffer("%%Pages: (atend)\n");
    Qddb_ConcatBuffer("%%EndComments\n");
    Qddb_ConcatBuffer("%%BeginProlog\n");
    Qddb_ConcatBuffer("/qddb 10 dict def qddb begin\n");
    for (i = 0; i < sizeof(defs)/sizeof(defs[0]); i++) {
	Qddb_ConcatBuffer(defs[i]);
	Qddb_ConcatBuffer("\n");
    }
    Qddb_ConcatBuffer("/ISOLatin1Encoding where{pop}{/ISOLatin1Encoding[\n");
    col = 0;
    for (i = 0; i < 256; i++) {
	int len = strlen(latin1[i]) + 1;
	col += len;
	if (col > 79) {
	    Qddb_ConcatBuffer("\n");
	    col = len;
	}
	Qddb_ConcatBuffer("/");
	Qddb_ConcatBuffer(latin1[i]);
    }
    Qddb_ConcatBuffer("\n] def}ifelse\nend\n");
    Qddb_ConcatBuffer("%%BeginSetup\n");
    Qddb_ConcatBuffer("%%IncludeResource: font ");
    Qddb_ConcatBuffer(font);
    Qddb_ConcatBuffer("\n");
    Qddb_ConcatBuffer("%%IncludeResource: font ");
    Qddb_ConcatBuffer(bold_font);
    Qddb_ConcatBuffer("\n");
    Qddb_ConcatBuffer("qddb begin\n");
    sprintf(tmpbuf, "/__%s ISOLatin1Encoding /%s RE\n", font, font);
    Qddb_ConcatBuffer(tmpbuf);
    sprintf(tmpbuf, "/R [ /__%s findfont %f scalefont /setfont load ] cvx def\n",
	   font, char_width/.6);
    Qddb_ConcatBuffer(tmpbuf);
    sprintf(tmpbuf, "/__%s ISOLatin1Encoding /%s RE\n", bold_font, bold_font);
    Qddb_ConcatBuffer(tmpbuf);
    sprintf(tmpbuf, "/B [ /__%s findfont %f scalefont /setfont load ] cvx def\n", 
	   bold_font, char_width/.6);
    Qddb_ConcatBuffer(tmpbuf);
    Qddb_ConcatBuffer("%%EndSetup\n");
    Qddb_ConcatBuffer("%%EndProlog\n");
}

static void PostscriptEpilogue()
{
    sprintf(tmpbuf, "%%%%Trailer\nend\n%%%%Pages: %d\n", pageno);
    Qddb_ConcatBuffer(tmpbuf);
}

/* p is ordered greatest position first */

static void PostscriptAddCharToLine(c, pos, p)
    int c;
    int pos;
    output_char **p;
{
    for (;; p = &(*p)->next) {
	if (*p == NULL || (*p)->pos < pos) {
	    output_char *tem = PostscriptAllocateChar();

	    tem->next = *p;
	    *p = tem;
	    tem->c = c;
	    tem->is_bold = 0;
	    tem->pos = pos;
	    break;
	} else if ((*p)->pos == pos) {
	    if (c == (*p)->c) {
		(*p)->is_bold = 1;
		break;
	    }
	}
    }
}

static void PostscriptContents(text)
    CONST char      *text;
{
    int             vpos = 0;
    int             hpos = 0;
    int             page_started = 0;
    int             esced = 0;
    output_char     *output_line = NULL;
    
    for (; *text != '\0'; text++) {
	if (esced) {
	    switch(*text) {
	    case '7':
		if (vpos > 0) {
		    if (output_line != NULL) {
			if (!page_started) {
			    page_started = 1;
			    PostscriptStartPage();
			}
			PostscriptPrintALine(output_line, vpos);
			output_line = 0;
		    }
		    vpos -= 1;
		}
		/* hpos = 0; */
		esced = 0;
		break;
	    default:
		/* silently ignore */
		esced = 0;
		break;
	    }
	} else {
	    switch (*text) {
	    case '\033':
		esced = 1;
		break;
	    case '\b':
		if (hpos > 0)
		    hpos--;
		break;
	    case '\f':
		if (!page_started)
		    PostscriptStartPage();
		PostscriptPrintALine(output_line, vpos);
		output_line = 0;
		PostscriptEndPage();
		hpos = 0;
		vpos = 0;
		page_started = 0;
		break;
	    case '\r':
		hpos = 0;
		break;
	    case '\n':
		if (output_line != NULL) {
		    if (!page_started) {
			page_started = 1;
			PostscriptStartPage();
		    }
		    PostscriptPrintALine(output_line, vpos);
		    output_line = 0;
		}
		vpos += 1;
		if (vpos >= lines_per_page) {
		    if (!page_started)
			PostscriptStartPage();
		    PostscriptEndPage();
		    page_started = 0;
		    vpos = 0;
		}
		hpos = 0;
		break;
	    case ' ':
		hpos++;
		break;
	    case '\t':
		hpos = ((hpos + tab_width)/tab_width)*tab_width;
		break;
	    default:
		if (!(isascii(*text) && iscntrl(*text))) {
		    PostscriptAddCharToLine(*text, hpos, &output_line);
		    hpos++;
		}
		break;
	    }
	}
    }
    if (output_line != NULL) {
	if (!page_started) {
	    page_started = 1;
	    PostscriptStartPage();
	}
	PostscriptPrintALine(output_line, vpos);
	output_line = 0;
    }
    if (page_started)
	PostscriptEndPage();
}


