'\"
'\" Copyright (C) 1997-2001 Herrin Software Development, Inc.
'\" All rights reserved.
'\" 
'\" This program is free software; you can redistribute it and/or
'\" modify it under the terms of the GNU General Public License
'\" as published by the Free Software Foundation; either version 2
'\" of the License, or (at your option) any later version.
'\" 
'\" This program is distributed in the hope that it will be useful,
'\" but WITHOUT ANY WARRANTY; without even the implied warranty of
'\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'\" GNU General Public License for more details.
'\" 
'\" You should have received a copy of the GNU General Public License
'\" along with this program; if not, write to the Free Software
'\" Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
.TH qddb_export 1 "21 Oct 2000" "QDDB Reference Manual" "Herrin Software Development, Inc."
.DA 21 Oct 2000
.SH NAME
qddb_export \- Export Qddb tables to various formats
.SH SYNOPSIS
.ft B
.nf
qddb_export csv ?options? <table_desc>
qddb_export as ?options? <table_desc>

Options:
    -concatsheets on|off                (default: off)
    -columntitles on|off                (default: off)
    -rowtitles on|off                   (default: off)
    -dateformat "date format"
    -separator "single char separator"  (default: ",")

.SH DESCRIPTION
\fIqddb_export\fR accepts a table descriptor as used
by the \fIqddb_table\fR command.   The return value
is a string suitable for immediate writing to a
file for import by other applications.   The most
common and portable format is CSV (comma-separated fields).

.TP
\fIcsv\fR
format produces an ASCII table in CSV format suitable for
import by many applications.   String values are encapsulated
with double quotes, and any double quotes in the value are
replaced with space characters.   Dates, integers, and
real numbers are not encapsulated with double quotes, so
you should make sure the destination application can read
dates in the format you specify.   Common date formats
include \fIdays1900\fR (number of days since January 1, 1900),
\fI%m/%d/%Y\fR (mm/dd/YYYY), and \fI%d/%m/%Y\fR (dd/mm/YYYY).
The default date format is either %m/%d/%y or %d/%m/%y depending
on whether you are using US or European dates.

.TP
\fIas\fR
format produces an ASCII string suitable for import directly
into Applix(TM) Spreadsheets.   The title of each table is
used as the title for a separate sheet.   Calculated fields
are not currently translated to AS format, but the current value
of each field \fBis\fR exported.

.SH SEE ALSO
qddb_import(n), qddb_instance(n), qddb_keylist(n),  qddb_rows(n), 
qddb_script(n), qddb_search(n), qddb_schema(n), qddb_tuple(n), 
qddb_view(n)

.SH BUGS
None known.

.SH ACKNOWLEDGEMENTS
Applix(TM) is a registered trademark of Applix, Inc.
