
/* $RCSfile: qcat.c,v $ $Revision: 2.0.0.1 $ $Date: 2000/11/09 15:06:08 $
 *
 * Copyright (C) 1993-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "Qddb.h"

void PrintKeyList _ANSI_ARGS_((Qddb_Schema *, Qddb_KeyList *));
int main _ANSI_ARGS_((int, char **));

int main(argc, argv)
    int				argc;
    char			**argv;
{
    char			Relation[BUFSIZ], *rel;
    Qddb_KeyList		*LastList = NULL;
    Qddb_Schema			*schema;
    off_t                       start_at;
    size_t                      how_many;

    if (argc < 2) {
	fprintf(stderr, "Usage: qcat RelationDir ?start how_many?\n");
	fflush(stderr);
	exit(1);
    }
    start_at = how_many = 0;
    Qddb_Init();
    if ((rel = Qddb_FindRelation(argv[1])) == NULL) {
	fprintf(stderr, "%s: cannot find relation %s\n", argv[0], argv[1]);
	exit(1);
    }
    if (argc == 4) {
	start_at = Qddb_BaseToOffset(argv[2], 10);
	how_many = Qddb_BaseToSize(argv[3], 10);
    }
    strcpy(Relation, rel);
    schema = Qddb_InitSchema(Relation);
    LastList = Qddb_CatRelation(schema, start_at, how_many);
    PrintKeyList(schema, LastList);
    exit(0);
}



void PrintKeyList(schema, list)
    Qddb_Schema		*schema;
    Qddb_KeyList	*list;
{
    Qddb_Entry		ThisEntry = NULL;
    char		*RelationFN = schema->RelationName;
    char		*buf;
    int			DBFile;

    DBFile = OpenDatabase(RelationFN, 0);
    while (list != NULL) {
	if (Qddb_ReadEntryByKeyList(DBFile, RelationFN, &ThisEntry, list, True) == -1) { /* invalid entry */
	    list = list->next;
	    continue;
	}
	Qddb_ReducedAttrToFullAttr(schema, ThisEntry);
	buf = (char *)Qddb_Convert(schema, QDDB_ENTRYTYPE_EXTERNAL, ThisEntry, QDDB_ENTRYTYPE_TCLEXTERNAL);
	if (buf == NULL) {
	    PANIC("Failed to convert entry\n");
	}
	write(fileno(stdout), buf, strlen(buf));
	putchar('\n');
	list = list->next;
    }
    close(DBFile);
}

