
/* $RCSfile: qindex.c,v $ $Revision: 2.0.0.1 $ $Date: 2000/11/09 15:06:08 $
 *
 * Copyright (C) 1993-2000 Herrin Software Development, Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "Qddb.h"

int main _ANSI_ARGS_((int, char **));

int main(argc, argv)
    int		     argc;
    char	     **argv;
{
    Qddb_Schema	     *ts;
    int		     hash_fd;
    Qddb_Boolean     verbose = False;
    char	     *RelationPath, HashFN[MAXPATHLEN];	
    
    if (argc < 2 || argc > 3) {
	fprintf(stderr, "Usage: %s [-v] Relation\n", argv[0]);
	exit(1);
    }
    qddb_stabilizing = 1;
    Qddb_Init();
    if (argc == 3) {
	if (strcmp(argv[1], "-v") == 0) {
	    verbose = True;
	} else {
	    fprintf(stderr, "Usage: %s [-v] Relation\n", argv[0]);
	    exit(1);
	}
	RelationPath = argv[2];
    } else {
	RelationPath = argv[1];
    }
    RelationPath = Qddb_FindRelation(RelationPath);
    ts = Qddb_InitSchema(RelationPath);
    if (ts == NULL) {
	if (qddb_errmsg != NULL) {
	    fprintf(stderr, "%s", qddb_errmsg);
	} else {
	    fprintf(stderr, "Unknown error '%d' while reading schema\n", qddb_errno);
	}
	fflush(stderr);
	exit(1);
    }
    strcpy(HashFN, RelationPath);
    strcat(HashFN, "/HashTable");
    hash_fd = Open(HashFN, O_RDWR, 0);
    if (hash_fd == -1) {
	fprintf(stderr, "Cannot open %s for writing\n", HashFN);
	exit(1);
    }
    Close(ts->hashtable_fd);
    ts->hashtable_fd = hash_fd;
    Qddb_MakeIndex(ts, verbose);
#if defined(DEBUG_MALLOC)
    dmalloc_shutdown();
#endif
    exit(0);
}
