#!/usr/local/bin/qtclsh
set maxrow 10
set maxcol 4
set t [qddb_table define $maxrow $maxcol -variable myvar]
set myvar(1,1) "hello linked world"
puts $myvar(1,1)
puts [qddb_table cell getval $t 1 1]
set names {{} a b c d e f g h i j} 
for {set i 1} {$i <= $maxcol} {incr i} {
	qddb_table col configure $t $i -type real -name [lindex $names $i]
	qddb_table row configure $t $i -name [lindex $names $i]
}
for {set i 1} {$i <= $maxrow} {incr i} {
	for {set j 1} {$j <= $maxcol} {incr j} {
		set myvar($i,$j) [expr $i * $j / 0.5]
	}
}
qddb_table configure $t -variable myvar
set maxrows [qddb_table row maxnum $t]
for {set i 1} {$i <= $maxrows} {incr i} {
	puts "$i: [qddb_table row getval $t $i]"
}
qddb_table col insert $t
qddb_table col configure $t $maxcol -type calc
for {set i 1} {$i <= $maxrows} {incr i} {
	qddb_table cell setval $t $i $maxcol "
		@avg(@range(@thisrow,1:@thisrow,[expr $maxcol - 1]))
	"
}
puts "-----\n[qddb_table getval $t -format text]\n-----"
qddb_table col clear $t $maxcol
qddb_table col configure $t $maxcol -type calc
if {![catch "set myvar(1,$maxcol) @sum(@cell(1,1),@cell(1,2))"]} {
	puts "Error: linked calculated field can be read"
}
for {set i 1} {$i <= $maxcol} {incr i} {
	qddb_table col configure $t $i -precision 2 -justify right
}
qddb_table col configure $t $maxcol -calc {
	@sum(@range(1,@thiscol:@if(@thisrow > 1,@thisrow-1,1),@thiscol),
             @cell(@thisrow,@thiscol)
            )
}
qddb_table cell setval $t 1 $maxcol 5
qddb_table col eval $t $maxcol
qddb_table configure $t -order column
puts "-----\n[qddb_table getval $t -format text -rowtitles on -coltitles on]\n-----"
qddb_table eval $t
puts "-----\n[qddb_table getval $t -format text -rowtitles on -coltitles on]\n-----"
qddb_table eval $t
puts "-----\n[qddb_table getval $t -format text -rowtitles on -coltitles on]\n-----"
qddb_table eval $t
puts "-----\n[qddb_table getval $t -format text -rowtitles on -coltitles on]\n-----"
qddb_table row eval $t 2
puts "-----\n[qddb_table getval $t -format text -rowtitles on -coltitles on]\n-----"
qddb_table col eval $t $maxcol
puts "-----\n[qddb_table getval $t -format text -rowtitles on -coltitles on]\n-----"
qddb_table cell eval $t 2 $maxcol
puts "-----\n[qddb_table getval $t -format text -rowtitles on -coltitles on]\n-----"

